package Log_graphs;
use Misc;

BEGIN {
#register all known graphs

 RegisterClass ('TMod_GzipGrapher', '','mod_gzip','MODGZIP_DESC',
 sub  { my $obj;  $obj = TMod_GzipGrapher -> new ();  return ($obj); } );

 RegisterClass ('TSnort_Grapher', '','snort','SNORT_DESC',
 sub  { my $obj;  $obj = TSnort_Grapher -> new ();  return ($obj); } );

}


package TMod_GzipGrapher;

use strict;
use Carp;
use Misc;
use Lstatobj;


use vars qw ( @ISA );
@ISA = qw ( TLogGrapher );

sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','mod_gzip');
 #setting default values
 $self -> {'TITLE_TAG'} = 'MODGZIP_DEFTITLE';
# $self -> {'HELP_FILE'} = 'ping.html'; #set help file
 $self -> {'VERTICAL_LABEL'} =$dict {'MODGZIP_LABEL'};
 $dict {'TABLE_DESC'} = $dict {'MODGZIP_TABLE'};
 $self -> {'DS_TYPE'} = 'ABSOLUTE'; #data source
# $self -> {'DS_TYPE'} = 'GAUGE'; #data source
 $self->{'NO_INSERT'} = 1; #this graph can not  delete and insert new adv properties
 $self -> {'HELP_FILE'} = 'mod_gzip.html'; #set help file

 #$self->{'EDIT_ADV'} = 0; #block editing of advanced properties
 $self -> {'ADV_DESC'} = {name => '', desc => '', size => 0, maxsize => 0};

 #$self -> {'ADV_DESC'} = {name => 'FILTER', desc => 'LOG_EDIT_FILTER', size => 20, maxsize => 40};

 bless ($self, $class);
 return $self;
}

sub ProcessLine {
  my ($self, $lineRef, $resRef) = @_;
  #process line from mog_gzip - apache log
  if ($$lineRef =~ /(\d+)\smod_gzip\:\s([^\s]+)\sIn\:(\d+)/) {
  my $in = $3; #bytes from input;
  $resRef->[1] += $1; #bytes send to client
  if ( $2 eq 'OK') {
   #for compressed
  $resRef->[0] += $3; #bytes send to client
  } else {
   #not compressed
  $resRef->[0] += $1; #bytes send to client
  }
}
}

#fill data on new objects
sub OnNew {
 my $self = shift;
 my @ADV_DATA;
 my %row;   #add to data
 $row {'COLOR'} = ''; #add
 $row {'DESC'} = 'Input'; #add
 $row {'BAR'} = 1;
 push (@ADV_DATA, { %row } ); #store
 $row {'COLOR'} = ''; #add
 $row {'DESC'} = 'Sent'; #add
 $row {'BAR'} = 0;
 push (@ADV_DATA, { %row } ); #store
 $self -> {'DESC'}{'ADV'} = [ @ADV_DATA ] ; #reference to object info


}

#-------------------------------------------TSnort_Grapher

package TSnort_Grapher;

use strict;
use Misc;
use Lstatobj;


use vars qw ( @ISA );
@ISA = qw ( TLogGrapher );

sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','snort');
 #setting default values
 $self -> {'TITLE_TAG'} = 'SNORT_DEFTITLE';
 $self->{'GAUGE_VAL'} = 1;
# $self -> {'HELP_FILE'} = 'ping.html'; #set help file
 $self -> {'VERTICAL_LABEL'} = $dict {'SNORT_LABEL'};
 $dict {'TABLE_DESC'} = $dict {'SNORT_TABLE'};
 $self -> {'DS_TYPE'} = 'GAUGE'; #data source
 $self -> {'HELP_FILE'} = 'snort.html'; #set help file

 $self->{'SHOW_TABLE_DATA'} = [(1,1,0,1,1)]; #define whitch columns can display
 bless ($self, $class);
 return $self;
}


#fill data on new objects
sub OnNew {
 my $self = shift;
 my @ADV_DATA;
 my %row;   #add to data
 $row {'COLOR'} = '';
 $row {'DESC'} = '';
 $row {'BAR'} = 1;
 $row {'FILTER'} = 'Denial of Service';
 push (@ADV_DATA, { %row } ); #store
 $row {'FILTER'} = 'Attempted Information Leak';
 push (@ADV_DATA, { %row } ); #store
 $row {'FILTER'} = 'PORTSCAN DETECTED';
 $row {'DESC'} = 'Portscan';
 push (@ADV_DATA, { %row } ); #store
 $row {'DESC'} = '';
 $row {'FILTER'} = 'Web Application Attack';
 push (@ADV_DATA, { %row } ); #store
 $row {'FILTER'} = 'Misc activity';
 push (@ADV_DATA, { %row } ); #store
  $self -> {'DESC'}{'ADV'} = [ @ADV_DATA ] ; #reference to object info


}

1;

