package Lstatobj;


#-----------------------------------------------------------------------------------------------
package TGrapher;
use CGI qw (:standard);
use CGI::Carp qw (fatalsToBrowser croak );
use RRDs;
use POSIX qw(strftime mktime ctime);
use Misc;
#use Misc qw ( %sysconfig %sysconfig %sysconfig);

my $Debugging = 0;

sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = {};
 #setting default values
 #my $configref = \%sysconfig;
 my %desc = ();
 $self -> {'CONFIG'} =\%sysconfig; #reference to program's config
 $self -> {'UCONFIG'} =\%userconfig; #reference to program's config
 $self -> {'TCONFIG'} =\%tempconfig; #reference to program's config
 $self -> {'HAS_INFO'} = 0; #set if object has additional info
 $self -> {'HELP_FILE'} = 'generic.html'; #set default help file
 $desc  {'NAME'} = 'default';
 $desc  {'TITLE'} = "\@\@TITLE\@\@";
 $desc  {'UPDATE_PERIOD'} = $userconfig { 'DEF_UPDATE_PERIOD' };
 $desc  {'WIDTH'} = $userconfig { 'DEF_WIDTH' };
 $desc  {'HEIGHT'} = $userconfig { 'DEF_HEIGHT' };
 my @Checkboxes; #table for name of checkboxes
 my @Radioboxes; #table for name of radioboxes
 $self ->{'CHKBOX'} = [ @Checkboxes ];
 $self ->{'RADIOBOX'} = [ @Radioboxes ];
 $self -> {'DESC'} = {%desc};
 $self -> {'EDIT_ADV'} = 1; #alow edit advanced properties
 bless ($self, $class);
 return $self;
}

#add to Checkbox table (for editing)
sub AddToCHKBOX {
 my $self = shift;
 my $box = $self ->{'CHKBOX'};
 foreach  my $val ( @_) {push (@$box, $val);}
}
#add to Radiobox table (for editing)
sub AddToRADIOBOX {
 my $self = shift;
 my $box = $self ->{'RADIOBOX'};
 foreach  my $val ( @_) {push (@$box, $val);}
}

#for debugging
sub debug {
 my $class = shift;
 $Debugging = shift;
}


#perparing create RRDfile, common for all objects
sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;
 #empty
 return 1;
}

#fill data for new object
sub OnNew {
 my $self = shift;
 return 1;
}


sub CreateRRD {
 my $self = shift;
 my $rrdstep = $self -> GetUpdinSec ();

#primary struct rrdfile
my @source =("--step",$rrdstep );

 my $ok =0;
 #data for each object
 if ($self -> Create_Object ($rrdstep * 2, \@source) ) { #value for update data sources
 #test if RRA record need
 my $norra=1;
 foreach (@source) {
  if ($_ =~ /^RRA/ ) {
   $norra = 0;
   last;
  }
 }

 if ($norra) {
  #add default rra records
 push (@source, "RRA:AVERAGE:0.5:1:600");
 push (@source, "RRA:AVERAGE:0.5:6:700");
 push (@source, "RRA:AVERAGE:0.5:24:775");
 push (@source, "RRA:AVERAGE:0.5:288:797");
 }
 my $rrdfilename = $self -> {'RRD_FILENAME'}; #name file to create

 RRDs::create ($rrdfilename, @source);
 my $ERROR = RRDs::error;
# carp "$0: unable to create `$rrdfilename': $ERROR\n" if $ERROR;
 $ok =1 if (! $ERROR);
 }
 return ($ok);
}


sub Update_Object {
 #empty
 return ("");
}

#update RRDfile
sub UpdateRRD {
 my $self = shift;

 my $values = $self -> Update_Object ();
 my $rrdfilename = $self -> {'RRD_FILENAME'}; #name file to update
 my $ok=0;
 if ($Debugging >  1 )  {
  print "Update $rrdfilename: \n$values\n";
 }
 if ($values) {
 RRDs::update ($rrdfilename, $values);
 my $ERROR = RRDs::error;
# carp "$0: unable to update `$rrdfilename': $ERROR\n" if $ERROR;
 $ok =1 if (! $ERROR);
 }
return ($ok);
}

#test security of object - empty-string: object OK
sub Check_Security {
 my $self = shift;
 return "";
}


#convert PERIOD to PERIOD in sec
sub GetUpdinSec {
 my $self = shift;
 $_ = $self -> {'DESC'}{'UPDATE_PERIOD'};
 (my $first, my $second) =  /(\d+)([mhdwM]?)/;
 if ($second) {
  #change to second
  SWITCH: {
   $second eq  'm' && do {
   		           $first *= 60;
   		           last SWITCH;
   		           };
   $second eq  'h' && do {
   		           $first *= 3600;
   		           last SWITCH;
   		           };
   $second eq  'd' && do {
   		           $first *= 3600 * 24;
   		           last SWITCH;
   		           };
   $second eq  'w' && do {
   		           $first *= 3600 * 24 * 7;
   		           last SWITCH;
   		           };
   $second eq  'M' && do {
   		           $first *= 3600 * 24 * 28;
   		           last SWITCH;
   		           };
  carp ("Unknown UPDATE PERIOD in $self->{'DESC'}{'NAME'}\n");
  }
 }
 return $first;
}

#set or read object's name
sub name {
 my $self = shift;
 if (@_) {
  my $newname = shift;
  croak "Invalid object name: $newname \n" if (!($newname =~ /^\w+$/));
  $self -> {'DESC'}{'NAME'} = $newname;
  $self -> {'RRD_FILENAME'} = $self -> {'CONFIG'}{'RRD_DIR'}.$newname.'.rrd'; # new rrd filename'';
#  $self -> {'PNG_FILENAME'} = $self -> {'CONFIG'}{'STAT_PNG_DIR'}.$newname; # new png graph filename'';
  $self -> {'OBJ_FILENAME'} = $self -> {'CONFIG'}{'OBJ_DIR'}.$newname.'.obj'; # new object filename'';
#  $self -> {'PNGURL'} = $self -> {'CONFIG'}{'STAT_PNG_URL'}.$newname; # new object filename'';
 }
 return $self -> {'DESC'}{'NAME'};
}

#set or read object's update period
sub UpdatePeriod {
 my $self = shift;
 if (@_) {$self -> {'DESC'}{'UPDATE_PERIOD'} = shift };
 return $self -> {'DESC'}{'UPDATE_PERIOD'};
}

#save object's data to default file
sub Save {
 my $self = shift;
 my $filename = $self ->{'OBJ_FILENAME'}; #filename
 $self -> SaveToFile ($filename);
}

#save object's data to  file
sub SaveToFile {
 my $self = shift;
 my $filename= shift;
 my $descref =  $self -> {'DESC'};
 #save content DESC to file
 $filename =~ s/\.\.//g;
 open (FILE, ">$filename" ) || carp "Can't create file $filename: $! \n";
 $self =~ /(\w+)=.*/; #extract object type
 print FILE "$1\n"; #Save object type
 foreach my $key  (keys %$descref) {
 my $value = $descref->{$key};
 if ( ref ($value) ){
  #save reference
  if  (ref ($value) eq "ARRAY") {
   #key as array
  print FILE "\[$key\]\n"; #begin
#  print @$value;
  if (@$value)  { #if has any elements
  for (my $i=0;$i<@$value;$i++) {
   my $HashRef = $$value[$i];
   foreach my $key2 (keys %$HashRef) {
    print FILE "$key2$i=",$$HashRef{$key2},"\n"; #print each value with number of position
   }
  }
  }
  print FILE "\[/$key\]\n"; #end
 }
 } else {
  #simply value
  print FILE "$key=$value\n";
  }
 }
 close FILE;
}

#load object's data from file
sub LoadFromFile {
 my $self = shift;
 my $filename = shift;
 my $descref =  ($self -> {'DESC'});

 #load content DESC to file
 $filename =~ s/\.\.//g;
 open (FILE, "<$filename" ) || carp "Can't open file $filename: $! \n";
 my @content=<FILE>;
 close FILE;
 #ignore object type
 shift @content;
 if (@content) {
 my $i=0;
 while ($i < @content)  {
  chomp (my $line=$content[$i]);
  if ($line =~ /=/ ) {
  #simply
  (my $key, my $value ) = split (/\=/,$line,2);
  $descref->{$key} = $value;
  $i++;
  }elsif ($line =~ /^\[(\w+)\]/ ) {
  #begin of array
  my @NewArray;
  my $ArrayName =$1;
  my $lastnum = -1;
  my $hashref;
  $i++;
  while ($content [$i++] =~ /^([a-z]+)(\d+)=(.*)/i) {
   #elements of array
   my $key2=$1;
   my $row= $2;
   my $value2=$3;
   chomp ($value2);
   $value2='' if (!defined ($value2));
   if ($row != $lastnum ) {
     #new row of data
     my %rowhash;
     $hashref = { %rowhash };
     push (@NewArray, $hashref);
     $lastnum ++;
    }
   $hashref-> {$key2} = $value2;
  }
 $descref->{$ArrayName} = [ @NewArray ]; #add to object
 } else {
  $i++; #skip end of array or ignore this line
  }
 } #end while
 }
 #setting some variables
 $self -> name ($self -> {'DESC'}{'NAME'}); # set new name for rrd, png;

}

#load object's data from default file
sub Load {
 my $self = shift;
 my $filename = $self->{'OBJ_FILENAME'}; #filename
 LoadFromFile ($self, $filename);
}


#prepare rrd draw source for each object
sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;
 #empty
}


sub Draw {
 my $self = shift;
 my $from =shift;
 my $to =shift;
 my $options = shift; #additional options for draw
 my $objoptions = shift; #additional options for object

 if (! defined ($options)) {
  $options ='';
 }
 if (! defined ($objoptions)) {
  $objoptions ='';
 }
 my $temp_id='';
 if ($objoptions) { #process changes in object's property
  chomp ($objoptions);
  $objoptions =~ s/^[^\w]+//; #clear unwanted chars from beginning
  my @addopt = split (/\&/, $objoptions);
  foreach (@addopt) {
   my ($key, $value) = split (/\=/,$_,2);
   $self->{'DESC'}{$key} = $value if (defined ($self->{'DESC'}{$key}));
  }
 my $err_msg;
 croak "Security violation: $err_msg" if ( ( $err_msg = $self ->Check_Security ())); #check security
 $temp_id=$$;
 }
 #get filename and url for  png file
 $instance ++;
 $instance = 0 if ($instance > 9999);
 my $tmp_hash=time; #get current time for tempolaty name
# $tmp_hash .= 'A'.$$.'_'.$self->name().'.png'; #add PID and objn name to temp name
 my $image_file=$temp_id.$instance.'_'.$self->name().'.png';
 $tmp_hash .= $$.$instance; #add PID and objn name to temp name
 $self -> {'PNG_FILENAME'} =$self -> {'CONFIG'}{'STAT_PNG_DIR'}.$image_file;
 $self -> {'PNGURL'} =$self -> {'CONFIG'}{'STAT_PNG_URL'}.$image_file.'?'.$tmp_hash;

 my @source = ();
 #some common values
 my $rrd = $self->{'RRD_FILENAME'};

 push (@source,"--title");
 my $title=$self -> {'DESC'}{'TITLE'};
 $title =~ s/\@\@TITLE\@\@/$dict{$self -> {'TITLE_TAG'}}/g; #set default title if defined
 push (@source,$title);
 push (@source,"--start");
 if ($from =~ /[^\d\-]/) {
  #period in short form
  $from = '-'.$from;
 }
 push (@source,"$from");
 push (@source,"--end");
 push (@source, $to);

 #save from and to values
 $self -> {'FROM'} = $from;
 $self -> {'TO'} = $to;

# push (@source,"--interlace");
 push (@source,"--imgformat");
 push (@source,"PNG");
 my $width=$self->{'DESC'}{'WIDTH'};
 my $height=$self->{'DESC'}{'HEIGHT'};
 $width *= $self -> {'UCONFIG'}{'H_SCALE'} if (defined ($self -> {'UCONFIG'}{'H_SCALE'}));
 $height *= $self -> {'UCONFIG'}{'V_SCALE'} if (defined ($self -> {'UCONFIG'}{'V_SCALE'}));
 push (@source,"--width=$width");
 push (@source,"--height=$height");
 push (@source,"--lower");
 push (@source,"0");
# push (@source,"--lazy");
 if  ($from =~/m/) {
 #different scale form month
 push (@source,"--x-grid");
 push (@source,"HOUR:24:DAY:7:DAY:2:0:\%d-\%m");
 }
 if  ($from =~/^\-\d+$/) {
 #for very short periods
 push (@source,"--x-grid");
 push (@source,"SECOND:20:MINUTE:1:MINUTE:2:0:\%H:\%M");
 }

 #connect with object data
 $self ->Draw_Object ($rrd, \@source);

 my $pngname = $self-> {'PNG_FILENAME'};
 my $pngurl = $self->{'PNGURL'};

(my $graphret, $width, $height) = RRDs::graph $pngname, @source;
my $ERROR = RRDs::error;
croak "$0: unable to graph $pngname: $ERROR\n" if $ERROR;

if (! ($options =~ /nohtml|png|only_name/i) ) {

print header if ($options =~ /html/i); #send header

#set here flag
print "<A name=\"$self->{DESC}{NAME}\"></A>\n";

if (! ($options =~ /nomenu/) ) {
#show additional functions
my $surl = $self -> {'TCONFIG'}{'SCRIPT_URL'};
my $selfurl = $self -> {'TCONFIG'}{'SELF_URL'};
my $iurl = $self -> {'CONFIG'}{'ICONS'};
my $editurl = $self -> {'CONFIG'}{'EDIT_URL'};
my $docurl = $self -> {'TCONFIG'}{'DOC'}.$self -> {'HELP_FILE'};
my $live_locked = $self -> {'UCONFIG'}{'LOCK_LIVE' };
my $moreinfo = $self -> {'UCONFIG'}{'MORE_INFO' };


my $objname = $self->{'DESC'}{'NAME'};
LoadLangData ('','draw');

print "<BR><TABLE  BORDER=0 WIDTH=$width BGCOLOR=$dict{'TABLE_HEADER_COLOR'} CELLSPACING=0><TR><TD VALIGN=CENTER>\n";

print "<A target=_blank HREF=$surl?obj=$objname\&template=table.html\&from=";
print $self->{'FROM'},'&to=',$self->{'TO'},"><IMG SRC=$iurl","table.gif BORDER=0 ALT=\"$dict{DRAW_TABLE}\"></A> \n";
if ($self -> {'HAS_INFO'} and $moreinfo) { #print icon additional info
 print "<A target=_blank HREF=$surl?obj=$objname\&action=info><IMG SRC=$iurl","info.gif BORDER=0 ALT=\"$dict{DRAW_INFO}\"></A> \n";
}
my $height2 = $height + 50;
my $width2 = $width + 20;

if (! $live_locked ){
print "<A HREF=\"javascript: void window.open(\'$surl?obj=$objname\&action=live\','',\'left=100,top=100,width=$width2,height=$height2\')\">\n";
print "<IMG SRC=$iurl","live.gif BORDER=0 ALT=\"$dict{DRAW_LIVE}\"></A> \n";
}
print "<A target=_blank HREF=\"$editurl?obj=$objname\"><IMG SRC=$iurl","prop.gif  BORDER=0 ALT=\"$dict{DRAW_PROP}\"></A> \n";

print "<A HREF=\"javascript: void refresh_it (\'$selfurl\#$self->{DESC}{NAME}\') \"><IMG SRC=$iurl","refone.gif  BORDER=0 ALT=\"$dict{DRAW_REFRESH}\"></A>";
print "</TD><TD ALIGN=RIGHT>\n";
print "<A target=_blank HREF=$docurl#draw><IMG SRC=$iurl","minihelp.gif BORDER=0 ALT=\"$dict{DRAW_HELP}\"></A> \n";
print "</TD></TR></TABLE>\n";
}

#show graph
print "<IMG SRC=$pngurl BORDER=0 WIDTH=$width HEIGHT=$height><BR>\n";
}

if  ($options =~ /png/i)  {
#generate png data
 print header (-type=>'image/png', -expires=>'+5s');
 $pngname =~ s/\.\.//g;
 open (PLIK,"<$pngname") or croak "Cant open $pngname";
 my @content =<PLIK>;
 print @content;
 close PLIK;
} elsif  ($options =~ /only_name/i)  {
 #print png name
 $pngname =~ s/^.*\///;  #remove directory info /
 print $pngname;
 }

}

sub ShowData { #print table with data
 my $self = shift;
 my $from = shift;
 my $to = shift;

my $datetimeformat = $self -> {'UCONFIG'}{'DATETF'}; #date and time format
my @source=('AVERAGE');
#change to another RRA type
$source [0] = $self -> {'RRATYPE'} if (defined ($self -> {'RRATYPE'}));

push (@source ,'--start');
push (@source ,$from);
push (@source , '--end');
push (@source , $to);

#show table with values

my ($start,$step,$names,$array) = RRDs::fetch ($self->{'RRD_FILENAME'}, @source);
my $ERROR = RRDs::error;
croak "RRD ERROR: $ERROR\n" if $ERROR ;

LoadLangData ('','draw');

print "<TABLE BORDER=1 BORDERCOLOR=#000000 CELLSPACING=0><TR BGCOLOR=#80FF80 ><TD>$dict{DRAW_TIME_SAMPLE}</TD>";
map {printf("<TD>%s</TD>",$_)} @$names ;
print "</TR>\n";
foreach my $line (@$array){
  print "<TR><TD BGCOLOR=yellow >",strftime ($datetimeformat, localtime($start)),"</TD>\n";
  $start += $step;
  foreach my $val (@$line) {
    if (defined ($val) ) {printf "<TD>%12.2f</TD>", $val }
     else {print "<TD>Undef</TD>"}
  }
  print "</TR>\n";
}
print "</TABLE>\n";
}

#EXTRA STATISIC
sub ExtraData {
 my $self = shift;
 my $gauge_val = shift; #for gauge values
 $gauge_val = 0 if (! defined ($gauge_val));

# my $RefRes = shift; #reference to table 0-Total, 1 AVG, 2 MAX, 3 MIN
 my %ResHash;

 #get from &to from object
 my $from =  $self -> {'FROM'};
 my $to =$self -> {'TO'};

my @source=('AVERAGE');
#change to another RRA type
$source [0] = $self -> {'RRATYPE'} if (defined ($self -> {'RRATYPE'}));

push (@source ,'--start');
push (@source ,$from);
push (@source , '--end');
push (@source , $to);

#show table with values

my ($start,$step,$names,$array) = RRDs::fetch ($self->{'RRD_FILENAME'}, @source);
my $ERROR = RRDs::error;
croak "RRD ERROR: $ERROR\n" if $ERROR ;

#alocate data for statistic
my @stat;
foreach (@$names) {
 push (@stat, [ 0,0,0,1E10,0 ]);   #defined samples, sum, max, min, last
}

foreach my $line (@$array){
  for ( my $i=0; $i<@$line;$i++) {
  my $val =$line->[$i];
    if (defined ($val) ) {
     $stat[$i][0]++; #inc valid samples
     $stat[$i][1] += $val;   #sum
     $stat[$i][2] = $val if ($val > $stat[$i][2]); #max
     $stat[$i][3] = $val if ($val < $stat[$i][3]);  #min
     $stat[$i][4] = $val; #last

      }
  }
}


foreach my $st (@stat) {
 my $AVG = 0;
 $AVG = $st->[1] / $st->[0] if ($st->[0]);
 # my $kas=/"/";
 my $Total= $st->[1];
 $Total *= $step if (! $gauge_val);

 #count results
 $st->[3] = 0  if ( ! $st->[0] ); #all undefined samples, set min to 0
 $ResHash {$names->[0]} = [$Total, $AVG, $st->[3],$st->[2],$st->[4] ];
 shift @$names;

 }
 return \%ResHash;
}


#EDIT

#prepare EDIT Object
sub Edit {
 my $self = shift;
 my $RefTags =shift;
 LoadLangData ('', 'edit'); #load info about edit parameters

#tabele update periods
 my %Upd_Periods = ('s',$dict{'EDIT_SEC'}, 'm',$dict{'EDIT_MIN'}, 'h', $dict{'EDIT_HOUR'}, 'd', $dict{'EDIT_DAY'},
 	'w', $dict{'EDIT_WEEK'}, 'M', $dict{'EDIT_MONTH'});
 my @periods= ('s', 'm', 'h', 'd', 'w', 'M');

 $$RefTags {'TEMP_OBJ_NAME'} = $self->{'DESC'}{'NAME'};
 $$RefTags {'HELP_FILE'} = $self->{'HELP_FILE'};
 my $DescRef = $self->{'DESC'};

 #extract all DESC tags;
 foreach my $key (keys %$DescRef) {
   $$RefTags {$key} = $$DescRef {$key};
 }
 #set update period

 my $period = $DescRef ->{'UPDATE_PERIOD'};
 $period =~ /(\d+)(\w*)/;
 my $value = $1;
 my $unit = $2;
 $unit = 's' if (! $unit); #default for second
 my @unit_list = scrolling_list('period_unit',
                                       \@periods,
                                       $unit,1,'',
                                       \%Upd_Periods);
  $$RefTags {'UPDATE_PERIOD_UNIT'} =  \@unit_list;
  $$RefTags {'UPDATE_PERIOD_VAL'} = $value;
 #prepate checkbox values;
 my $CheckBOX = $self ->{'CHKBOX'};
 if (@$CheckBOX) {
  foreach my $ch (@$CheckBOX) {
   my $newname= $ch.'_BOX';
   if ($DescRef ->{$ch}) { $$RefTags {$newname} = 'CHECKED'}
   else { $$RefTags {$newname} = ''}
   }
 }

 #prepare for radiobox values;
 $CheckBOX = $self ->{'RADIOBOX'};
 if (@$CheckBOX) {
  foreach my $ch (@$CheckBOX) {
   my $newname= $ch.'_BOX';
   my $val = $DescRef ->{$ch};
   for ( my $i=0; $i < 5; $i++) {
    if ($i ==$val) {$$RefTags {$ch.'_'.$i} = 'CHECKED' }
     else {$$RefTags {$ch.'_'.$i} = '' }
   }
   }
 }
 Gen ($RefTags, 'eobjpri1.html', 1);
 #for additional primary options
 $self -> EditObjPrimary ($RefTags); #edit additional
 Gen ($RefTags, 'eobjpri2.html', 1);
 #for advanced options
 $self -> EditObjAdvanced ($RefTags) if ( $self->{'EDIT_ADV'});

 #finish prepare
 Gen ($RefTags, 'eobjend.html', 1);

}


#edit additional primary fields
sub EditObjPrimary {
}

#edit advanced fields
sub EditObjAdvanced {
}


sub PostEdit {
 my $self = shift;
 my $RefTags =shift;
 my $RefPostTags =shift;
 my $displayPage =shift;
 #process posttags
# while ( my ($key, $value) =each  %$RefPostTags) {
 # print "$key=$value\n--";
 #}

 $$RefTags {'OBJ_NAME'} = $$RefPostTags {'OBJ_NAME'};

 my $DescRef = $self->{'DESC'};
 #store all DESC tags;
 foreach my $key (keys %$DescRef) {
  if (defined ($$RefPostTags {$key})) {
   $$DescRef {$key} = $$RefPostTags {$key} if (! ($key =~ /\d$/));
   }
 }
 #convert UPDATE_PERIOD
 my $update_unit = $$RefPostTags {'period_unit'};
 if (defined ($update_unit)) {
  $update_unit ='' if ($update_unit eq 's');
  $DescRef ->{'UPDATE_PERIOD'} = $$RefPostTags {'UPDATE_PERIOD_VAL'}.$update_unit;
 }

 #process checkboxes only if primary
 if (!($$RefPostTags {'RESULT'} =~ /OK_EL|NEW_EL|DEL_EL/)) {
  my $CheckBOX = $self ->{'CHKBOX'};
 if (@$CheckBOX) {
  foreach my $ch (@$CheckBOX) {
   my $newname= $ch.'_BOX';
   if (defined ($$RefPostTags {$newname})) { $DescRef ->{$ch} = 1}
   else { $DescRef ->{$ch} = 0}
   }
 }
 }

 $self -> PostEditObjPrimary ($RefPostTags); #save additional primary options
 $self -> PostEditObjAdvanced ($RefPostTags) if ( $self->{'EDIT_ADV'}); #save advanced options
 #save current context
 $self->Save;

 #prepare tags for new display
 $self -> Edit ($RefTags) if ($displayPage);
}

sub PostEditObjPrimary {
}

sub PostEditObjAdvanced {
}

sub EndEdit {
 my $self = shift;
 my $RefTags =shift;
 my $Finally =shift;
 my $Primary = $$RefTags {'OBJ_NAME'}; #name of primary object

 if ($Finally==1) {
  #I'm sure to recreate rrd and end edit
  unlink ($self -> {'OBJ_FILENAME'}); #delete tempolary object file
 #test if DEMO version
 if (IF_DEMO ()) {
  Gen ($RefTags, 'demo.html', 1);
 } else {
  $self -> name ($Primary); #change name to primary
  my $err;
  if (! ($err = $self->Check_Security ())) {
  #test if advanced fields are filled
	 my $AdvData  = $self -> {'DESC'}{'ADV'}; #reference to array statistic info
	 if ( defined ($AdvData) ) { #if has any advanced data ?
	 if ( ! @$AdvData ) {
          $$RefTags {'ERROR'} =  "This graph needs more data (press NEW ELEMENT & OK)";
          Gen ($RefTags, 'error.html', 1);
	  exit;
	    }
 	}	
	$self -> Save; #save with new values
  	if (! ($err = Misc::SendMsg (3, $Primary))) { #send message to recreate rrd file
  		Gen ($RefTags, 'thanks.html', 1);
  	} else {
    	#problems with SendMsg
  	$$RefTags {'ERROR'} = $err;
  	Gen ($RefTags, 'error.html', 1);
  	}
  } #end security
   else {
    #not secure
    $$RefTags {'ERROR'} = "Some fields have bad value: $err";
   Gen ($RefTags, 'error.html', 1);
   }
}
 }
  elsif ($Finally==2) {
  #drop edi object
  unlink ($self -> {'OBJ_FILENAME'}); #delete tempolary object file
  Gen ($RefTags, 'abort.html', 1);

  } elsif ($self->CompareEdit ($Primary)) {
  #need recreate
  Gen ($RefTags, 'ask.html', 1);
  } else {
  #end edit

  unlink ($self -> {'OBJ_FILENAME'}); #delete tempolary object file
  #test if advanced fields are filled
	 my $AdvData  = $self -> {'DESC'}{'ADV'}; #reference to array statistic info
	 if ( defined ($AdvData) ) { #if has any advanced data ?
	 if ( ! @$AdvData ) {
          $$RefTags {'ERROR'} =  "This graph needs more data (press NEW ELEMENT & OK)";
          Gen ($RefTags, 'error.html', 1);
	  exit;
	    }
 	}	

 #test if DEMO version
 if (IF_DEMO ()) {
  Gen ($RefTags, 'demo.html', 1);
 } else {
  $self -> name ($Primary); #change name to primary

  my $err;
  if (!( $err = $self->Check_Security ())) {  
  $self -> Save; #save with new values
  #send info for update service data
  SendMsg (2, $self->name());

  Gen ($RefTags, 'thanks.html', 1);
  } #end security
 else {
    #not secure
    $$RefTags {'ERROR'} = "Some fields have bad value: $err";
   Gen ($RefTags, 'error.html', 1);
   }

 }
  }
}

#compare objects, if they need recrate rrd file
sub CompareEdit {
 my $self = shift;
 my $Primary = shift;
 my $Result = 0;

 my $obj = LoadObjectByName ($Primary); # load object to memory
 if (! defined ($obj)) { croak "Can't load object: $Primary \n" }

 #check update period
 if ($self->{'DESC'}{'UPDATE_PERIOD'} ne $obj->{'DESC'}{'UPDATE_PERIOD'} ) {
  $Result = 1;
 } else { $Result = $self->CompareEditObj ($obj) }

 return ($Result); # 1 - need recreate
}

sub CompareEditObj {
 return (0);
}

#show additional info
sub Info {
}

#save and restrore params before unload from memroy
sub Save_Params {
}

sub Restore_Params {
}

#--------------TADVGRAPHER--------------------------------------------------------------------------
package TADVGrapher;
use vars qw ( @ISA );
use Misc;
use Misc qw ( ConvB );
@ISA = qw ( TGrapher );

sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 #LoadLangData ('','ip');
 #setting default values
 my @ADV_DATA;

 $self -> {'DESC'}{'ADV'} = [ @ADV_DATA ] ; #reference to object info
 $self -> {'ADV_DESC'} = [ ]; #structure for description data
 $self -> {'DS_TYPE'} = 'COUNTER'; #or GAUGE for typicall applications
 $self -> {'VERTICAL_LABEL'} =''; #vertical label
 $self -> {'BAR'} = 0; # 1 for user bar select
 $self -> {'HIDE_PARAM'} = 1; # 1 for user bar select
 $self->{'NO_INSERT'} = 0; #this graph can delete and insert new adv properties
 $self->{'NO_TABLE'} = 0; #this graph has table
 $self->{'SHOW_TABLE_DATA'} = [(1,1,1,1,1)]; #define whitch columns can display
 bless ($self, $class);
 return $self;
}

#create typical object for advanced data
sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 my $DataRef =  $self -> {'DESC'}{'ADV'}; #reference to array of partitions

 #read limits
 my $limit='U';
 $limit = $self -> {'MAX_VALUE'} if (exists ($self -> {'MAX_VALUE'}));

 my $min_value='0';
 $min_value = $self -> {'MIN_VALUE'} if (exists ($self -> {'MIN_VALUE'}));

if (@$DataRef) { #has any elements
 my $type = $self -> {'DS_TYPE'};
 for (my $i=0; $i < @$DataRef; $i++) {
   push (@$Refsource,"DS:val$i:$type:$rrdstep:$min_value:$limit");
 }
 return 1;
 }
 else {return 0}

}

#draw basic graph
sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

 ResetPalette (); #reset default color palette

 my $DataRef  = $self -> {'DESC'}{'ADV'}; #reference to statistic info
 my $labelsize = 30;
 my $vert_lab = $self -> {'VERTICAL_LABEL'};
 push (@$Refsource,"--vertical-label");
 push (@$Refsource,$vert_lab);

 my $refinfo = $self -> {'ADV_DESC'};

if (@$DataRef) {
my $refdata;
  if (! $self->{'NO_TABLE'}) {
  my $tabledesc = $dict {'TABLE_DESC'};
  $tabledesc = 'Table description' if (! defined ($tabledesc));
  push (@$Refsource,"COMMENT:$tabledesc\\s");
  push (@$Refsource,"COMMENT:\\s");
  my $gauge_val = $self->{'GAUGE_VAL'};
  $gauge_val = 0 if ( ! defined ($gauge_val));
  $refdata = $self->ExtraData ($gauge_val); #get extra data
 }
  #first draw only bars
if ($self  -> {'BAR'}) { #if can use bars
my $firstbar=1;
 for (my $i=0; $i < @$DataRef; $i++) {
   my $Row = $DataRef ->[$i]; #reference to hash
   my $Bar=0;
   my $hide =0;
   $Bar = $Row->{'BAR'} if (defined ($Row->{'BAR'}));
   next unless ($Bar);
   $hide = $Row->{'HIDE'} if (defined ($Row->{'HIDE'}));
   next if ($hide);

   push (@$Refsource,"DEF:val$i=$rrd:val$i:AVERAGE");
   my $colour = $Row->{'COLOR'};
   $colour = GetColor() if (! $colour); #automatic

   my $desc ='';
   $desc = $Row->{'DESC'} if (defined ($Row->{'DESC'}));
   $desc =$Row->{$refinfo->{'name'}} if (! $desc); #if not defined or empty, use name of first parameter

   if ($firstbar) {
   #first
    push (@$Refsource,"AREA:val$i\#$colour:$desc");
    $firstbar=0;
    }
    else {
    #not first bar
     push (@$Refsource,"STACK:val$i\#$colour:$desc");
   }

 if (! $self->{'NO_TABLE'}) {
 my $data = $refdata -> {"val$i"}; #stats for output
 my $spacing = " " x ($labelsize -length ($desc));
  push (@$Refsource,"COMMENT: $spacing");

  #print table
  my $tableline='';
  for (my $j=0; $j<@$data;$j++) {
  if ($self->{'SHOW_TABLE_DATA'}[$j]) {
     #convert to Kilo Mega or Giga
     $data->[$j] = ConvB ($data->[$j]);
     $tableline .="$data->[$j] ";
     }
  }
  push (@$Refsource,"COMMENT:$tableline") if ($tableline);

  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");
 }
 }#end for bars
}#end bars
#now lines
 for (my $i=0; $i < @$DataRef; $i++) {
   my $Row = $DataRef ->[$i]; #reference to hash
   my $Bar=0;
   my $hide=0;
   $Bar = $Row->{'BAR'} if (defined ($Row->{'BAR'}));
   next if ($Bar);
   $hide = $Row->{'HIDE'} if (defined ($Row->{'HIDE'}));
   next if ($hide);
   push (@$Refsource,"DEF:val$i=$rrd:val$i:AVERAGE");
   my $colour = $Row->{'COLOR'};
   $colour = GetColor () if (! $colour); #automatic

   my $desc ='';
   $desc = $Row->{'DESC'} if (defined ($Row->{'DESC'}));
   $desc =$Row->{$refinfo->{'name'}} if (! $desc); #if not defined or empty, use name of first parameter
    push (@$Refsource,"LINE2:val$i\#$colour:$desc");

 if (! $self->{'NO_TABLE'}) {
  my $data = $refdata -> {"val$i"}; #stats for output
  my $spacing = " " x ($labelsize -length ($desc));
  push (@$Refsource,"COMMENT: $spacing");

  #print table
  my $tableline='';
  for (my $j=0; $j<@$data;$j++) {
  if ($self->{'SHOW_TABLE_DATA'}[$j]) {
     #convert to Kilo Mega or Giga
     $data->[$j] = ConvB ($data->[$j]);
     $tableline .="$data->[$j] ";
     }
  }
  push (@$Refsource,"COMMENT:$tableline") if ($tableline);

  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");
 }
 }#end for bars
 }#end data ref

}




#prepare to edit partitions info
sub EditObjAdvanced {
 my $self = shift;
 my $RefTags = shift;

 my $PartRef =  $self -> {'DESC'}{'ADV'}; #reference to array of partitions
 my $bar = $self -> {'BAR'} ; # 1 for user bar select
 my $hide = $self -> {'HIDE_PARAM'} ; # 1 for hide select

 if ($self -> {'NO_INSERT'}) {
  Gen ($RefTags, 'ebegadv2.html', 1);
 } else {
  Gen ($RefTags, 'ebegadv.html', 1);
  }
 my $refinfo = $self -> {'ADV_DESC'};
 if (@$PartRef) { #has any element;
#  while ( my ($d, $v) = each  %dict) {   print "$d=$v\n";}

  print "<TABLE BORDER\=1 BGCOLOR=\"#CACAFF\" CELLSPACING=0 CELLPADDING=0 >\n";
  print "<TR BGCOLOR=\"#A0A0FF\"><B><TD><FONT COLOR=red>*</FONT>$dict{EDIT_POS}</TD>\n"  if (! ($self -> {'NO_INSERT'}));
  my $desc = $refinfo ->{'desc'}; #ref to hash
  my $desc1;
  if ( defined ($desc) and $desc) {
   $desc1 = $dict {$desc};
   $desc1 = '' if (! defined ($desc1));
   print "<TD>$desc1</TD>\n";
  }
  print "<TD>$dict{EDIT_COLOR}</TD>\n";
  print "<TD>$dict{EDIT_DESC}</TD>\n";
  print "<TD>$dict{EDIT_BAR}</TD>\n" if ($bar);
  print "<TD>$dict{EDIT_HIDE}</TD>\n" if ($hide);

  print "</B></TR>\n"; #end header

  for (my $i=0; $i<@$PartRef; $i++) {
   my $HashRef = $$PartRef [$i];
   print "<TR><TD><INPUT TYPE=CHECKBOX NAME=\"$i\" ></TD>\n" if (! ($self -> {'NO_INSERT'})); #position
  if (defined ($desc1)) {
  my $name = $refinfo -> {'name'};
  my $size = $refinfo -> {'size'};
  my $maxsize = $refinfo -> {'maxsize'};
  if (! defined ($maxsize)) { $maxsize = 5 * $size }
  print "<TD><INPUT TYPE=\"text\" NAME=\"$name$i\" VALUE=\"";
  print $$HashRef {$name};
  print "\" SIZE=$size MAXLENGTH=$maxsize ></TD>\n";
  }
  #color and description
  print "<TD><INPUT TYPE=\"text\" NAME=\"COLOR$i\" VALUE=\"";
  print $$HashRef {'COLOR'};
  print "\" SIZE=6 MAXLENGTH=6 ></TD>\n";
  print "<TD><INPUT TYPE=\"text\" NAME=\"DESC$i\" VALUE=\"";
  print $$HashRef {'DESC'};
  print "\" SIZE=40 MAXLENGTH=60 ></TD>\n";

  my $checked = '';
  if ($bar) {
  $checked ='CHECKED' if ($$HashRef {'BAR'});
  print "<TD><INPUT TYPE=CHECKBOX NAME=\"BAR$i\" $checked ></TD>\n";
  } #end check box
  if ($hide) {
  $checked = '';
  $checked ='CHECKED' if ($$HashRef {'HIDE'});
  print "<TD><INPUT TYPE=CHECKBOX NAME=\"HIDE$i\" $checked ></TD>\n";
  } #end check box

  print "</TR>\n";
  }
  print "</TABLE>\n";
 }
 Gen ($RefTags, 'eendadv.html', 1);
}

sub PostEditObjAdvanced {
 my $self = shift;
 my $RefPostTags =shift;

 my $Result=0;
 my $refinfo = $self -> {'ADV_DESC'}; #description of collumns
 my $bar = $self -> {'BAR'} ; # 1 for user bar select
 my $hide = $self -> {'HIDE_PARAM'} ; # 1 for user hide select

 #catch end form's action
 $Result = $RefPostTags->{'RESULT'} if ( defined ($RefPostTags->{'RESULT'}));

 if (( $Result eq 'NEW_EL') or #run only if advanced data was edited
     ( $Result eq 'DEL_EL') or
     ( $Result eq 'OK_EL') ) {
 my @NewPart;
 $self -> {'DESC'}{'ADV'} = [ @NewPart ]; #reference to array of partitions
 my $PartRef = $self -> {'DESC'}{'ADV'};
 #save all elements to array
 #while (my ($k, $v) =each %$RefPostTags) { print "$k=$v\n"};
 my $i = 0;
 my $del = (($Result eq 'DEL_EL') and (! ($self->{'NO_INSERT'}))); #if delete any element
 my $n = $refinfo->{'name'}; #parameter name

 my $first = 'COLOR';
 while (defined ($RefPostTags->{"$first$i"}) ) {
  if (! (defined ($RefPostTags->{$i}) && $del )) {
  my %row;   #add to data
   $row {$n} = $RefPostTags->{"$n$i"} if (defined ($n) and $n);
   $row {'COLOR'} = $RefPostTags->{"COLOR$i"}; #add
   $row {'DESC'} = $RefPostTags->{"DESC$i"}; #add
   if ($bar) {
   if (defined ($RefPostTags->{"BAR$i"})) {
   $row {'BAR'} = 1;
    } else {   $row {'BAR'} = 0;}
   } #end checkbox
   if ($hide) {
   if (defined ($RefPostTags->{"HIDE$i"})) {
   $row {'HIDE'} = 1;
    } else {   $row {'HIDE'} = 0;}
    }
  push (@$PartRef, { %row } ); #store
  }
  $i++;
 }

 if (($Result eq 'NEW_EL') and (! ($self->{'NO_INSERT'}))){
  #pressed New Element
  my %NewHash;
  my $n = $refinfo -> {'name'}; #name of column
  $row {$n} = "" if (defined ($n) and $n);
  $NewHash {$n} = "";
  $NewHash {'COLOR'} = "";
  $NewHash {'DESC'} = "";
  $NewHash {'BAR'} = 0 if ($bar);
  $NewHash {'HIDE'} = 0 if ($hide);
  push (@$PartRef, { %NewHash });
 }
}
}

#check if need recreate RRD file
sub CompareEditObj {
 my $self = shift;
 my $newobj = shift;
 my $Result = 0;
 my $newobjpart = $newobj-> {'DESC'}{'ADV'};
 my $objpart = $self-> {'DESC'}{'ADV'};
 if (@$newobjpart != @$objpart ) {
  $Result=1; #difference in elements count
   }
 return ($Result);
}

#chceck security
sub Check_Security {
 my $self = shift;

 return ( $self -> SUPER::Check_Security ());
}

#---------END TADVGRAPHER-----------------------------------
#----------TLOGGRAPHER-------------------------------------
package TLogGrapher;

use strict;
use Carp;
use Misc;

use vars qw ( @ISA );
@ISA = qw ( TADVGrapher );

sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 #setting default values
 $self -> {'TITLE_TAG'} = 'LOG_DEFTITLE';
# $self -> {'HELP_FILE'} = 'ping.html'; #set help file
 $self -> {'VERTICAL_LABEL'} ='clicks';
 $self -> {'DS_TYPE'} = 'GAUGE'; #data source
 $self -> {'DESC'}{'LOG_NAME'} = ''; #path to log name
 $self -> {'DESC'}{'LIMIT'} = 0; #tempolary limit
 $self -> {'UPDATE_PERIOD'} = '1h';

 $self ->{'POS'} = -1; #last position in file log
 $self ->{'BAR'} = 1; #show bar in edit mode

 $self -> {'ADV_DESC'} = {name => 'FILTER', desc => 'LOG_EDIT_FILTER', size => 20, maxsize => 40};

 bless ($self, $class);
 return $self;
}

#edit additional primary fields
sub EditObjPrimary {
my $self = shift;
my $RefTags = shift;

#show additional template for this object
Misc::Gen ($RefTags, 'elogpri.html',1);
}

#check security
sub Check_Security {
 my $self = shift;
 my $log = $self -> {'DESC'}{'LOG_NAME'};
 my $sysconf = $self -> {'CONFIG'};
 my $ok=  $self -> SUPER::Check_Security ();
 if ($log ) {
 return ('LOG NAME have to full name file') if ( ($log =~ /^[^\/]/) or ($log =~ /\.\./ ));
 if (exists ($sysconf -> {'LOG_PATH'})) {
 #check if log on log_path
 my $log_path = $sysconf -> {'LOG_PATH'};
 my @paths = split (/\:/, $log_path);
 $ok = "LOG NAME have to be on path in LOG_PATH in config";
 #test each path
 foreach my $p ( @paths) {
  my $l = $log;
  $l =~ s/^$p//;
  return ("") if ($l =~ /^\/[^\/]+$/); #exit if found
 }
  }
 } 
 return ($ok);
}




#update values in RRD file
sub Update_Object {
 my $self = shift;
 my $start=time;

 my $pos = $self ->{'POS'};
 my $logfile = $self ->{'DESC'}{'LOG_NAME'};
 $logfile =~ s/\.\.//g;
 if (open (LOG, "<$logfile")) {
 if ($pos <0) {
 seek (LOG, 0, 2); #end of file
 $self ->{'POS'} = tell (LOG); #store position
 $start = ""; #return undefined
 }
  else {
  my $curend = sysseek (LOG, 0, 2);
  if ($curend > $pos ) {
   seek (LOG, $pos, 0);
  }
  my $RefAddr  = $self -> {'DESC'}{'ADV'}; #reference to statistic info
  my @Results;
  foreach  ( @$RefAddr) { push (@Results, 0) } #fill with 0

  while (defined (my $line = <LOG>)) {
  #process this line
  $self->ProcessLine (\$line, \@Results);
  } #end while
 $self ->{'POS'} = tell (LOG); #store position
 foreach  ( @Results) { $start .=':'.$_ } #append results
 }
 close LOG;

 } #end open
 return ($start);
}

#process line
sub ProcessLine {
  my ($self, $lineRef, $resRef) = @_;
  my $RefAddr  = $self -> {'DESC'}{'ADV'}; #reference to statistic info
  #search for corresponding filters

  for (my $i=0; $i <@$RefAddr; $i++) {
  my $ref = $RefAddr -> [$i];
  my $filter = $ref -> {'FILTER'};
  if ($$lineRef =~ /$filter/ ) {
   #
   $resRef -> [$i] ++;
  }
 }

}

#save and restrore params before unload from memroy
sub Save_Params {
 my $self =shift;
 my $list = shift;
 $list->{'POS'} = $self ->{'POS'};
}

sub Restore_Params {
 my $self =shift;
 my $list = shift;
 if (defined ( $list->{'POS'})) {
 $self ->{'POS'} = $list->{'POS'};
 print "POS set on $self->{POS}\n" if ($Debugging >  1 );
 }
}


#----------END TLOGGRAPHER-------------------------------------

