package Misc;
use strict;
use Carp;
use Socket;
require  Exporter;

#--------MISC------------------------------------------------
use vars qw ( @ISA @EXPORT @EXPORT_OK %sysconfig %userconfig %tempconfig $defcolour @defcolour1 @defcolour2 $instance %dict $lastrun $valid_langs);
@ISA = qw(Exporter);
@EXPORT= qw ( %sysconfig %userconfig %tempconfig Gen SendMsg show_file show_command get_page_index IF_DEMO $instance %dict LoadLangData RegisterClass
	CreateObjByClass $lastrun LoadObjectByName LoadObjects LoadObjectByFileName ResetPalette GetColor ); #export by default
@EXPORT_OK = qw ( OpenUserConfig SaveUserConfig GetClassesNames $valid_langs ConvB SetLang OpenConfig SaveConfig Initialize_configs ); #optional export


@defcolour1 = ('ff0000','0000ff','00A000','000001','ff00ff','800000','ffff00','00ffff','ff6600','808080'); #table defaults colours (STANDARD)
#pastel
@defcolour2 =('ff6584','656bff','99dd92','ffa560','ff65f4','e29191','6bff63','ff4040','65c4ff','00000','949ace','b394cc','65ffcc','cc96b1','cca499','dfe592','ad65ff','94c4d3');
my $defcolour; #reference to default palette

$instance=0; #number for marking instances objects
my $curcolor=0;

#for language options
my $LANG;
my $DEF_SKIN;
my $SKIN;
#my $valid_langs;

my %LoadedLangfile;
my $user_config_mtime;
my $sys_config_mtime;


#array of availble classes
my %Classes;


#program's config
BEGIN {
%sysconfig =();
%userconfig =();
%tempconfig =();
%dict = (); #dictionary for language conversion



#my $configfile='@@ ETCDIR@@config';
#my $userconfigfile='@@ PAGESDIR@@user.config';
my $configfile='/etc/lstat/config';
my $userconfigfile='/var/lib/lstat/pages/user.config';

Initialize_configs (); #initialize config files

sub OpenUserConfig {
 my $refhash = shift;
 OpenConfig ($userconfigfile, $refhash);
}

#choose available language & load
sub LoadLangData {
 my $dir = shift;
 my $filename = shift;
 $dir = 'standard' if (! $dir);
 my $id = $dir.'/'.$filename;

 if ( ! defined (  $LoadedLangfile {$id}) )  { #check if already loaded
 my $langdir =  $sysconfig  {'TEMPLATE_DIR'}.$dir.'/';  #lang directory
 my $langfile = $langdir.$LANG.'/'.$filename ;
 $langfile = $langdir.'default/'.$filename if ( ! -e $langfile ); #try default language if not exists

 #load translation data into dictionary
 $langfile =~ s/\.\.//g;
 
 open (FILE, "<$langfile") || croak ("Cant open language data file $langfile : $!\n");
 my @data = <FILE>;
 close FILE;

#process all lines
foreach my $line (@data){
 chomp ($line);
 if ($line =~ /^\w.*=/) {
  my ($key, $value) = split (/=/,$line,2);
  $dict {$key} =$value;
  }
 }

 $LoadedLangfile {$id} = 1; #mark already loaded
 }
}

#read config into memory
sub OpenConfig {
my $configfile = shift;
my $refhash = shift;

$configfile =~ s/\.\.//g;
open (FILE, "<$configfile") || croak ("Cant open configfile $configfile : $!\n");
my @cfg = <FILE>;
close FILE;

#process config file
foreach my $line (@cfg){
 chomp ($line);
 if ($line=~/^\w/) {
  my ($key, $value) = split (/=/,$line,2);
  $$refhash {$key} =$value;
  }
 }
}



sub SaveConfig {
my $filename = shift;
my $refhash = shift;

$filename =~ s/\.\.//g;

open (FILE, ">$filename") || croak ("Cant save configfile $filename : $!\n");
#process config file
while (my ($key, $value) = each %$refhash) {
 print FILE "$key=$value\n";
}
close FILE;

}

sub SaveUserConfig {
my $refhash = shift;
SaveConfig ($userconfigfile, $refhash);
}



sub Initialize_configs {

#test for config file modyfication date

my $u_mtime = (stat ($userconfigfile)) [9]; #user config modyfication time
my $s_mtime = (stat ($configfile)) [9]; #system config modyfication time
if (defined  ($user_config_mtime) and defined ( $sys_config_mtime)) {
 return if (($u_mtime == $user_config_mtime) and ($s_mtime == $sys_config_mtime));
}
#store modyfication times
$user_config_mtime = $u_mtime;
$sys_config_mtime = $s_mtime;

undef %sysconfig;
undef %userconfig;
undef %tempconfig;
undef  %LoadedLangfile;
undef %dict = (); #dictionary for language conversion

OpenConfig ($userconfigfile, \%userconfig);   #read user config
OpenConfig ($configfile, \%sysconfig);     #read main config

$DEF_SKIN='sky';
$SKIN=$DEF_SKIN;

$defcolour = \@defcolour1; #reference to default palette
if (defined ($userconfig {'PALETTE'})) {
 $defcolour = \@defcolour2  if ($userconfig {'PALETTE'} eq 'color_pastel'); #reference to default palette
} else {
 $userconfig {'PALETTE'} = 'color_std';
}

#list of valid languages
$valid_langs ='en,pl';

$LANG= $userconfig{'LANG'} if (defined ($userconfig{'LANG'}));

#LANG not set in config
if (! defined ($LANG) ) {
  SetLang ('auto'); #load info about language
} else {
 SetLang ($LANG); #load info about language
}
$SKIN=$userconfig{'SKIN'} if (defined ($userconfig{'SKIN'}));
#load skin info data
my $skininfofile =  $sysconfig  {'TEMPLATE_DIR'}.'skins/'.$SKIN.'/skininfo';  #skin info file
OpenConfig ($skininfofile, \%dict);

#set default url
$tempconfig{'IMG'} = $sysconfig{'SKIN_URL'}.$SKIN.'/uni/';

#set language
sub SetLang {
 my $lang=shift;
 $lang='en' if ($lang =~ /\W/);

 if ($lang =~ /auto/) {
 #try autodetect
  $lang="en"; #set default

 if (defined ($ENV {'HTTP_ACCEPT_LANGUAGE'} )) {
  #run in cgi env
  my $lang2 =$ENV {'HTTP_ACCEPT_LANGUAGE'} ;
  $lang2 =~ /^(\w+)/;
  $lang2 = $1;
  if (defined ($lang2)) {
  $lang= $lang2 if ( $valid_langs =~ /$lang2/i);
  }
 }
}

 if ( $valid_langs =~ /$lang/i) {
  $LANG= $lang;
  LoadLangData ('', 'langinfo'); #load info about language
  #set default url
 $tempconfig{'DOC'} = $sysconfig{'DOC_URL'}.$LANG.'/';
 $tempconfig{'LANG_IMG'} = $sysconfig{'SKIN_URL'}.$SKIN.'/'.$LANG.'/';
  }
}

}




} #end BEGIN


#test if DEMO version
sub IF_DEMO {
 my $result = 0;
 $result = $sysconfig {'DEMO'} if (defined ($sysconfig {'DEMO'}));
 return ($result);
}



sub FindTemplate {
 my $template=shift; #filename to find
 my $myskin = shift;
 my $skindir =  $sysconfig  {'TEMPLATE_DIR'}.'skins/'.$myskin.'/';  #skin directory
 my $skinfile=$skindir.$LANG.'/';
 my $TemplateFile = $skinfile.$template;
 return ($TemplateFile);
}


#genreating page
sub Gen {
 my $RefTags = shift; #Reference to tags array
 my $template = shift; #template to view
 my $kind = shift; #kind of template
 my $TemplateFile;
 my $old_img;
 my $old_langimg;
 my $use_def = 0;

 #security check
  if ( ! ( $template =~ /^[\w\.]+\w+$/i ) ) {
    $RefTags ->{'ERROR'} = 'Invalid template or page name!';
    $template = 'error.html';
    }
 #end security check
       
 if (defined ($kind)) { # 1 - from skins directory
  $TemplateFile =  FindTemplate ($template, $SKIN);
  if ( ! -e $TemplateFile) {  #use default template if not extist
  $use_def =1;
  $old_img = $RefTags ->{'IMG'};
  $old_langimg = $RefTags ->{'LANG_IMG'};
  $TemplateFile =  FindTemplate ($template, $DEF_SKIN);
  #change references to default skin
  $RefTags ->{'IMG'} = $sysconfig{'SKIN_URL'}.$DEF_SKIN.'/uni/';
  $RefTags ->{'LANG_IMG'} = $sysconfig{'SKIN_URL'}.$DEF_SKIN.'/'.$LANG.'/';
  }
 } else
  {
  $TemplateFile = $sysconfig  {'PAGE_DIR'}.$template;
  }
 
 $TemplateFile =~ s/\.\.//g;
 
 open (FILE, "<$TemplateFile" ) || croak "Can't open template file $TemplateFile: $! \n";
 my @content = <FILE>;  #load content template into memory
 close FILE;
 #printing template file
 foreach (@content)  {
 #find @@ tags @@
 if (/\@\@[\w\$][^\@]+\@\@/ ) {
 #tag found
  my $linecopy = $_;
  my $linecopy2 = $_;

  while ($linecopy =~ /\@\@([\w\$][^\@]+)\@\@/g ) {

  my $tag = $1; #tag name
  my $i = index ($linecopy2, "\@\@$tag\@\@");

  if ($i ) { print substr ($linecopy2 , 0, $i )}; #print content before tag
  $linecopy2 = substr ($linecopy2, $i+4+length ($tag), 65535); #delete taginfo
  #find tag value
  if (defined ($RefTags-> { $tag } )) {
   if (! ref ($RefTags-> { $tag })) {
     print $RefTags-> { $tag }; #found text in Tags array
    } else  {
     #tag as referencr\e
     if ( ref ($RefTags-> { $tag }) eq "ARRAY") {
      #print all strings in array
     foreach (@{$RefTags-> { $tag }}) {
      print;
      }
     } else {
     $RefTags-> { $tag }->($RefTags); #run this code
     }
    }} #end found tag
     else {
     #unknown tag
     if ($tag =~ /^(\w*)\$(.*)$/ )
      {
       if (!$1) { #empty fistr arg, default for draw object
        $RefTags-> { 'DRAW' }->($2); #draw object
       } else
        { #run external code
         $RefTags-> { $1 }->($RefTags, $2);
        }
      }
       elsif ( $tag eq 'ALL' ) {
                         #print all tags
                        foreach my $key (keys %$RefTags ) {
                          print "<B>$key</B>=$RefTags->{$key}<BR>\n";
                         }       }
      else {
     #really unknown tag
      croak "Unknown tag $tag in $TemplateFile \n";
      }
    }

  } ##while
  print $linecopy2; #print rest of line

 } #if 1
  else  {print} #print simply HTML line
 } #forech
if ( $use_def ) {
 #restore skin info
 $RefTags ->{'IMG'} = $old_img ;
 $RefTags ->{'LANG_IMG'} =  $old_langimg ;
}

}

#----------------------------------------------------------------------
#send message to daemon
sub SendMsg {
 my $Msg=shift;
 my $id = shift;
 my $filename = $sysconfig {'SOCKET'};

 socket(SOCK, PF_UNIX, SOCK_STREAM, 0)	|| return "SendMsg socket: $!";
 connect(SOCK, sockaddr_un($filename))	|| return "SendMsg connect: $! \
  (probably <B>lstatd</B> isn't running)";
# $SIG {'CLD'} = "IGNORE";

 # split the program into two processes, identical twins
 my $kidpid;
 die "can't fork: $!" unless defined($kidpid = fork());

 if ($kidpid) {
   my  $rin ='';
   my $line ='';
   vec ($rin, fileno (SOCK),1)=1;
   #wait for data or timeout
   if (select ($rin, undef, undef,20)) {
    $line = <SOCK>;
    } else {croak "Timeout in SendMessage\n"}

#    kill("TERM" => $kidpid);        # send SIGTERM to child
}
else {
    # child send message to the socket
    print SOCK "$Msg $id\n";
    CORE::exit() if (exists ($ENV{'MOD_PERL'})); #for mod_perl
    exit;
}
 return "";
}

#-----------------------------------------------------------------------------------


#print file i n HTML
sub show_file {
 my $filename = shift;
 $filename =~ s/\.\.//g;
 
 if (open (FILE, "<$filename") && (my @content = <FILE>) && (close FILE)) {
 foreach my $line (@content) {
  chomp ($line);
  print "$line<BR>\n";
  }
 }
}

#show command in HTML
sub show_command {
my $command=shift;
$command =~ s/\.\.//g;

if (open (FILE,"$command 2>&1 |") && (my @content=<FILE>) && (close FILE)) {
  foreach my $line (@content) {
   chomp ($line);
   print "$line<BR>";
  }
 }

}

#load page index with descriptions
sub get_page_index {
  my $Ref = shift;
  my $options =shift;

  my $indexfile=$sysconfig {'PAGE_INDEX'};
  $indexfile =~ s/\.\.//g;
  if (open (FILE, "<$indexfile") && (my @pgindex=<FILE>) && (close FILE)) {
   foreach my $line (@pgindex) {
	chomp ($line);
	my ($key, $value) = split (/=/,$line,2);
	if ( ! defined ($options)) {
	 #change to default page name if exists
	$value =~ s/\@\@(\w+_PAGE)\@\@/$dict{$1}/ if ($value =~ /\@\@(\w+_PAGE)\@\@/ );
	}

	$Ref -> {$key} = $value;
  }
  }
}


#register object class
sub RegisterClass {
 my $name = shift;
 my $dir = shift;
 my $langfile = shift;
 my $desc = shift;
 my $constructor = shift;

 $Classes {$name} = [ $dir, $langfile, $desc, $constructor ];
}

#create object by class name
sub CreateObjByClass {
 my $classname = shift;
 my $ret;
 if (defined ($Classes {$classname})) { #if registred
  my $classdesc=$Classes {$classname};
  my $classconstuctor = $$classdesc [3];
  #run constructor
  $ret = $classconstuctor -> ();
 }
 return ($ret);
}

#get names of all clases with description
sub GetClassesNames {
 my $RefHash = shift;
 foreach my $classname ( keys %Classes ) {
  my $cd = $Classes {$classname};
  #load description
  LoadLangData ($$cd[0],$$cd[1]);
  #extract class description
  $RefHash->{$classname} = $dict {$$cd[2]};
 }

}


#convert value to Kilo, Mega, Giga
sub ConvB {
 my $data = shift;
 my $res='';
 my @mul=('K','M','G','T','P'); #table prefixes
  if ($data < 1024) {
  $res = int ( $data);
 } else {
 my $i=-1;
 do {
  $data /= 1024;
  # my $kas=/"/";
  $i++;
  } until  ($data < 1024);
  if ($data < 10) {
  $res = sprintf ("%.2f", $data);
  } elsif ($data < 100)  {
  $res = sprintf ("%.1f", $data);
  } else {$res = int ($data)}

  $res .= $mul[$i]; #add prefix
 }

 my $sp =  " " x (6 -length ($res));
 $res =$sp.$res; #add spaces
 return $res;
}


#-------------------------------------------------------------------------------------------------------------

#load all objects in memory
sub LoadObjects {
my $objref = shift;

my $objdir = $sysconfig {'OBJ_DIR'};
opendir (DIR, $objdir) || carp "Can't opendir $objdir: $! \n";
my @objfiles = grep { /^[a-z]\w+\.obj/i } readdir (DIR);
closedir DIR;

foreach my $filename (@objfiles) {
 push (@$objref, LoadObjectByFileName ($objdir.$filename));
}
}

#load one object by name
sub LoadObjectByName  {
my $name = shift;
return LoadObjectByFileName  (  $sysconfig {'OBJ_DIR'}.$name.'.obj');
}

#load one object from file
sub LoadObjectByFileName  {
my $filename = shift;
my $obj;
#my $MyConfig = \%sysconfig;
 $filename =~ s/\.\.//g;
 if ( open (FILE, "<$filename" ) ) {
 my $objtype = <FILE>; #Object's type i first line
 chomp ($objtype);
 close FILE;
 $obj = CreateObjByClass ($objtype);
 if (! defined ($obj)) {  carp "Unknown object type $objtype in $filename .\n" }

 $obj ->LoadFromFile ($filename); #loading data of object
 }
return $obj;
}

#------------------------------------------------------------
sub ResetPalette {
 $curcolor=-1;
}
#get default color
sub GetColor {
 $curcolor++;
 $curcolor = 0 if (! defined ($defcolour -> [$curcolor]));
 return ($defcolour ->[$curcolor]);
}

1;





