package Std_obj;
use Misc;

BEGIN {
#register all known graphs

 RegisterClass ('TCPUGrapher', '','cpu','CPU_DESC',
 sub  { my $obj;  $obj = TCPUGrapher -> new ();  return ($obj); } );
 RegisterClass ('TMEMGrapher', '','mem','MEM_DESC',
 sub  { my $obj;  $obj = TMEMGrapher -> new ();  return ($obj); } );
 RegisterClass ('TLOADGrapher', '','load','LOAD_DESC',
 sub  { my $obj;  $obj = TLOADGrapher -> new ();  return ($obj); } );
 RegisterClass ('TPARTGrapher', '','part','PART_DESC',
 sub  { my $obj;  $obj = TPARTGrapher -> new ();  return ($obj); } );
 RegisterClass ('TDISKGrapher', '','disk','DISK_DESC',
 sub  { my $obj;  $obj = TDISKGrapher -> new ();  return ($obj); } );
 RegisterClass ('TINTGrapher', '','int','INT_DESC',
 sub  { my $obj;  $obj = TINTGrapher -> new ();  return ($obj); } );
 RegisterClass ('TIPGrapher', '','ip','IP_DESC',
 sub  { my $obj;  $obj = TIPGrapher -> new ();  return ($obj); } );
 RegisterClass ('TPINGGrapher', '','ping','PING_DESC',
 sub  { my $obj;  $obj = TPINGGrapher -> new ();  return ($obj); } );

}

# TCPUGRAPHER-------------------------------------------------------------

package TCPUGrapher;
use vars qw ( @ISA );
use Carp;
use Misc;
use Lstatobj;

@ISA = qw ( TGrapher );
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 #setting default values
 LoadLangData ('','cpu');
 $self -> name ( 'cpuXX');
 $self -> {'HAS_INFO'} = 1; #this object has additional info
 $self -> {'TITLE_TAG'} = 'CPU_DEFTITLE'; #tag od default title
 $self -> {'HELP_FILE'} = 'cpu.html'; #set help file

 $self -> {'DESC'}{'UPDATE_PERIOD'} = '1m';
 bless ($self, $class);
 return $self;
}

sub Info {
 my $self=shift;
  #show cpuinfo
show_file ($self -> {'CONFIG'}{'PROC_CPUINFO'});
}
sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 #for CPU additional  MAX value
 push (@$Refsource, "RRA:AVERAGE:0.5:1:600");
 push (@$Refsource, "RRA:AVERAGE:0.5:6:700");
 push (@$Refsource, "RRA:AVERAGE:0.5:24:775");
 push (@$Refsource, "RRA:AVERAGE:0.5:288:797");
 push (@$Refsource,"RRA:MAX:0.5:1:600");
 push (@$Refsource,"RRA:MAX:0.5:6:700");
 push (@$Refsource,"RRA:MAX:0.5:24:775");
 push (@$Refsource,"RRA:MAX:0.5:288:797");

 push (@$Refsource,"DS:user:COUNTER:$rrdstep:0:U");
 push (@$Refsource,"DS:system:COUNTER:$rrdstep:0:U");
 push (@$Refsource,"DS:idle:COUNTER:$rrdstep:0:U");
  return 1;

}

#update values in RRD file
sub Update_Object {
 my $self = shift;
 my $filename = $self -> {'CONFIG'}{'PROC_STAT_FILE'};
 my $start=time;
 my @value =();
 open (FILE, "<$filename" ) || carp "Can't open file $filename: $! \n";
 my @allvalues=<FILE>;
foreach (@allvalues) {
 if (/^cpu\s/) {
  @value = split;
  last;
  }
}
close FILE;
 $value[1] += $value [2]; #all user usage together
#finally update RRD file
 return ("$start:$value[1]:$value[3]:$value[4]");
}


sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

  push (@$Refsource,"--upper");
  push (@$Refsource,"100");
  push (@$Refsource,"--vertical-label");
  push (@$Refsource,$dict{'CPU_VLABEL'});
  push (@$Refsource,"COMMENT: $dict{CPU_TABLE_CAPTION}");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");

  push (@$Refsource,"DEF:user=$rrd:user:AVERAGE");
  push (@$Refsource,"DEF:system=$rrd:system:AVERAGE");
  push (@$Refsource,"DEF:idle=$rrd:idle:AVERAGE");
  push (@$Refsource,"CDEF:all=user,system,+,idle,+");
  push (@$Refsource,"CDEF:us=user,100,*,all,/");
  push (@$Refsource,"CDEF:sys=system,100,*,all,/");
  push (@$Refsource,"CDEF:alls=us,sys,+");
  push (@$Refsource,"AREA:sys#FF0000:$dict{CPU_SYSTEM}");
  #correct for translations
  my $spacing = " " x (12 -length ($dict{'CPU_SYSTEM'}));
  push (@$Refsource,"COMMENT: $spacing");

  push (@$Refsource,"GPRINT:sys:MAX: \%2.lf");
  push (@$Refsource,"COMMENT:   ");
  push (@$Refsource,"GPRINT:sys:LAST:\%2.lf");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"STACK:us#0000FF:$dict{CPU_USER}");
 $spacing = " " x (12 -length ($dict{'CPU_USER'}));
  push (@$Refsource,"COMMENT: $spacing");

  push (@$Refsource,"GPRINT:us:MAX: \%2.lf");
  push (@$Refsource,"COMMENT:   ");
  push (@$Refsource,"GPRINT:us:LAST:\%2.lf");
  push (@$Refsource,"COMMENT:\\s");
 #push (@sources,"HRULE:50#FF0000:ala");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:$dict{CPU_TOTAL} ");
  $spacing = " " x (13 -length ($dict{'CPU_TOTAL'}));
  push (@$Refsource,"COMMENT: $spacing");

  push (@$Refsource,"GPRINT:alls:MAX: \%2.lf");
  push (@$Refsource,"COMMENT:   ");
  push (@$Refsource,"GPRINT:alls:LAST:\%2.lf");
}



#---------------------------------------------------------------
package TMEMGrapher;
use vars qw ( @ISA );
use Carp;
use Misc;
use Lstatobj;

@ISA = qw ( TGrapher );
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','mem');
 #setting default values
 $self -> name ( 'memXX');
 $self -> {'TITLE_TAG'} = 'MEM_DEFTITLE';
 $self -> {'HELP_FILE'} = 'mem.html'; #set help file
 bless ($self, $class);
 return $self;
}


sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 push (@$Refsource,"DS:total:GAUGE:$rrdstep:0:U");
 push (@$Refsource,"DS:used:GAUGE:$rrdstep:0:U");
 push (@$Refsource,"DS:buffers:GAUGE:$rrdstep:0:U");
 push (@$Refsource,"DS:cached:GAUGE:$rrdstep:0:U");
 push (@$Refsource,"DS:swap:GAUGE:$rrdstep:0:U");
 push (@$Refsource,"DS:swapused:GAUGE:$rrdstep:0:U");
  return 1;

}

#update values in RRD file
sub Update_Object {
 my $self = shift;
 my $filename = $self -> {'CONFIG'}{'PROC_MEM_FILE'};
 my $start=time;
 my %values;
 open (FILE, "<$filename" );
 my @allvalues=<FILE>;
 foreach (@allvalues) {
  if (/^(\w+):\s+(\d+)\skB/) {
   $values{$1} = $2 * 1024;
  }
 }
 close FILE;
 my $MemUsed = $values{'MemTotal'} - $values{'MemFree'};
 my $SwapUsed = $values{'SwapTotal'} - $values{'SwapFree'};
	      
 #finally update RRD file
 return ("$start:$values{'MemTotal'}:$MemUsed:$values{'Buffers'}:$values{'Cached'}:$values{'SwapTotal'}:$SwapUsed");
}
			
sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

  push (@$Refsource,"--upper");
  push (@$Refsource,"100");
  push (@$Refsource,"--vertical-label");
  push (@$Refsource,$dict {'MEM_VLABEL'});

  push (@$Refsource,"DEF:total=$rrd:total:AVERAGE");
  push (@$Refsource,"DEF:used=$rrd:used:AVERAGE");
  push (@$Refsource,"DEF:buffers=$rrd:buffers:AVERAGE");
  push (@$Refsource,"DEF:cached=$rrd:cached:AVERAGE");
  push (@$Refsource,"DEF:swap=$rrd:swap:AVERAGE");
  push (@$Refsource,"DEF:swapused=$rrd:swapused:AVERAGE");

  push (@$Refsource,"CDEF:all=total,swap,+");
  push (@$Refsource,"CDEF:prog=used,buffers,-,cached,-");
  push (@$Refsource,"CDEF:progd=prog,100,*,all,/");
  push (@$Refsource,"CDEF:buffersd=buffers,100,*,all,/");
  push (@$Refsource,"CDEF:cachedd=cached,100,*,all,/");
  push (@$Refsource,"CDEF:swapd=swapused,100,*,all,/");

  push (@$Refsource,"CDEF:totalk=total,1024,/");
  push (@$Refsource,"CDEF:usedk=used,1024,/");
  push (@$Refsource,"CDEF:free=totalk,usedk,-");

  push (@$Refsource,"AREA:cachedd#FFFF00:$dict{MEM_CACHE}");
  push (@$Refsource,"STACK:buffersd#00FF00:$dict{MEM_BUFFERS}");
  push (@$Refsource,"STACK:progd#0000FF:$dict{MEM_PROGS}");
  push (@$Refsource,"STACK:swapd#FF0000:$dict{MEM_SWAP}");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:$dict{MEM_TABLE_CAPTION}");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"GPRINT:totalk:LAST:\%8.lf");
  push (@$Refsource,"GPRINT:usedk:LAST:\%6.lf");
  push (@$Refsource,"GPRINT:free:LAST:\%6.lf");

  push (@$Refsource,"CDEF:totals=swap,1024,/");
  push (@$Refsource,"CDEF:useds=swapused,1024,/");
  push (@$Refsource,"CDEF:frees=totals,useds,-");

  push (@$Refsource,"GPRINT:totals:LAST:\%10.lf");
  push (@$Refsource,"GPRINT:useds:LAST:\%6.lf");
  push (@$Refsource,"GPRINT:frees:LAST:\%6.lf");
  push (@$Refsource,"COMMENT:[KB]");
}


#---------END_TMEM------------------------------------------
package TLOADGrapher;
use vars qw ( @ISA );
use Carp;
use Misc;
use Lstatobj;

@ISA = qw ( TGrapher );
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','load');
 #setting default values
 $self -> name ( 'loadXX');
 $self -> {'DESC'}{'UPDATE_PERIOD'} = '1m';
 $self -> {'TITLE_TAG'} = 'LOAD_DEFTITLE';
 $self -> {'DESC'}{'LOW_LEVEL'} = 1;
 $self -> {'DESC'}{'HIGH_LEVEL'} = 2;
 $self -> {'DESC'}{'TYPE'} = 0;
 $self -> AddToCHKBOX ('TYPE');
 $self -> {'HAS_INFO'} = 1; #this object has additional info
 $self -> {'HELP_FILE'} = 'load.html'; #set help file
 bless ($self, $class);
 return $self;
}

sub Info { #additional info
 my $self = shift;
 my $uptime = $self -> {'CONFIG'}{'UPTIME'};
 show_command ($uptime);
 $uptime = $self -> {'CONFIG'}{'PROC_VERSION'};
 show_file ($uptime);
 $uptime = $self -> {'CONFIG'}{'REDHAT'};
 show_file ($uptime);
 }

sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 push (@$Refsource,"DS:load:GAUGE:$rrdstep:0:U");
  return 1;

}

#update values in RRD file
sub Update_Object {
 my $self = shift;
 my $filename = $self -> {'CONFIG'}{'PROC_LOAD_FILE'};
 my $start=time;
 my @value =();
 open (FILE, "<$filename" ) || carp "Can't open file $filename: $! \n";
 my $allvalues=<FILE>;
  @value = split ('\s',$allvalues);

 close FILE;
#finally update RRD file
 return ("$start:$value[0]");
}


sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

 my  $typ= $self-> {'DESC'}{'TYPE'} ; #type of graph
 my $lowlevel=$self-> {'DESC'}{'LOW_LEVEL'} ; #low level od system load
 my $highlevel=$self-> {'DESC'}{'HIGH_LEVEL'} ; #jigh level od system load

  push (@$Refsource,"--vertical-label");
  push (@$Refsource,$dict{LOAD_VLABEL});

  push (@$Refsource,"DEF:load=$rrd:load:AVERAGE");

 if ($typ) {
 push (@$Refsource,"CDEF:loadok=load,$lowlevel,MIN");
 push (@$Refsource,"CDEF:loadwarn=load,$lowlevel,LT,UNKN,load,$lowlevel,-,$highlevel,$lowlevel,-,MIN,IF");
 push (@$Refsource,"CDEF:loadhot=load,$highlevel,LT,UNKN,load,$highlevel,-,IF");
 } else {
 push (@$Refsource,"CDEF:loadok=load,POP,$lowlevel,0,-");
 push (@$Refsource,"CDEF:loadwarn=load,POP,$highlevel,$lowlevel,-");
 push (@$Refsource,"CDEF:loadhot=load,POP,INF");
 }
 push (@$Refsource,"AREA:loadok#00FF00:$dict{LOAD_LOW}");
 push (@$Refsource,"STACK:loadwarn#FFFF00:$dict{LOAD_MED}");
 push (@$Refsource,"STACK:loadhot#FF0000:$dict{LOAD_HI}");
 push (@$Refsource,"LINE2:load#000001:$dict{LOAD_VAL}") if (! $typ);
 push (@$Refsource,"GPRINT:load:LAST:$dict{LOAD_LAST} \%2.2lf");
}


#edit additional primary fields
sub EditObjPrimary {
my $self = shift;
my $RefTags = shift;

#show additional template for this object
Misc::Gen ($RefTags, 'eloadpri.html',1);
}


#---------End-TLOAD-----------------------------------------
package TDISKGrapher;
use vars qw ( @ISA );
use Carp;
use Misc;
use Lstatobj;

@ISA = qw ( TGrapher );
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','disk');
 #setting default values
 $self -> name ( 'diskXX');
 $self -> {'TITLE_TAG'} = 'DISK_DEFTITLE';
 $self -> {'DESC'}{'TYPE'} = 1;
 $self -> AddToRADIOBOX ('TYPE'); #for radio box
 $self -> {'DESC'}{'DISK'} = "";
 $self -> {'HELP_FILE'} = 'disk.html'; #set help file
 bless ($self, $class);
 return $self;
}

sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 push (@$Refsource,"DS:read:COUNTER:$rrdstep:0:1E6");
 push (@$Refsource,"DS:write:COUNTER:$rrdstep:0:1E6");
  return 1;

}


#for disk stats
my %idemajor=(3,'a',
              22,'c',
              33,'e',
              34,'g',
              56,'i',
              57,'k');

my $scsimajor=8;
my %disktable = (); #list with disks data
my %validdisk = (); #table valid disks
my $diskcollected=0;
my $diskcollectstart=0;
my $lastrunme=0;

sub Create_valid_disks {
#build list valid disks
my $procpart = $sysconfig{'PROC_PART_FILE'};
open (FILE, "<$procpart") || die "Cant open $procpart: $! \n";
my @stat = <FILE>;
close FILE;

foreach my $line ( @stat) {
 $line =~ s/^\s+//g;
 if ($line =~ /^\d+/ ) {
  my ($major, $minor, $blocks, $name, $rest) = split (/\s+/,$line,5);
  if ($name =~ /^[sh]d[a-z]+$/) {
  my $disknum = ord (substr ($name, 2, 1)) - ord 'a';
  $validdisk {$name} = [ $major, $minor, $disknum, $blocks];
  }
 }
}

}




#collect diskstats
sub diskcollect {
my $procstat;
my @stat;
my $letter;

if ($lastrunme != $lastrun) {
$lastrunme = $lastrun;
$diskcollectstart = time;

$procstat = $sysconfig{'PROC_DISKSTATS_FILE'};
if ( -e $procstat ) {
#2.6.x version
open (FILE, "<$procstat") || die "Cant open $procstat: $! \n";
@stat = <FILE>;
close FILE;
foreach (@stat) {
 if (/^\s+(\d+)\s+(\d+)       #major and minor device number
     \s+(\w+)			#disk name
     \s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)
     \s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)  #disk params 
 /x){
#disk device
 $disktable {$3} = [0,$4,$6,$8,$10];
# print "$3 $4 $6 $8 $10\n";
} elsif (/^\s+(\d+)\s+(\d+)       #major and minor device number
     \s+(\w+)			#partition name
     \s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)  #disk params  
 /x){
#disk partition 
 $disktable {$3} = [0,$4,$5,$6,$7];
# print "$3 $4 $5 $6 $7\n";
}
}

} else {
 if (! $diskcollected ) { #create table valid disks
  Create_valid_disks ();
  $diskcollected=1;
 }
#2.4.x version
#collect disk data
$procstat = $sysconfig{'PROC_STAT_FILE'};
open (FILE, "<$procstat") || die "Cant open $procstat: $! \n";
@stat = <FILE>;
close FILE;
#for kernel 2.2. style
my @olddiskstat;

foreach (@stat) {
 if (/^disk_io:/){
  while (/\((\d+)\,(\d+)\)\:\((\d+)\,(\d+)\,(\d+)\,(\d+)\,(\d+)\)/g){
   #check for ide
   if (defined ($idemajor{$1})) {
    #disk ide
    my $disknr = $2;
    if ($disknr > 1) {
     #try workaround kernel 2.4 bug
     $disknr = $disknr - 2;
    }
    $letter = chr ( ord ($idemajor{$1}) + $disknr);
    $disktable {"hd$letter"} = [$3,$4,$5,$6,$7];

   } elsif ($1 == $scsimajor) {
     $letter = chr ( ord ('a') + $2);
    $disktable {"sd$letter"} = [$3,$4,$5,$6,$7];
    }
  }
  last;
 } elsif (/^disk[\s\_]/ ) {
   #kernel 2.2.X style
   s/^\w+\s//g; #delete first chars
   my @diskline = split;
   push (@olddiskstat, [@diskline]) ;
  }

}

if (@olddiskstat) {
 #for kernels 2.2.X
 foreach my $diskname (keys %validdisk ) {
  my $ref = $validdisk {$diskname};
  my $disknum = $$ref [2];
  if (defined ($olddiskstat[4] [ $disknum ])) {
   $disktable {$diskname} = [$olddiskstat[0][$disknum],
                            $olddiskstat[1][$disknum],
			    $olddiskstat[3][$disknum],
			    $olddiskstat[2][$disknum],
			    $olddiskstat[4][$disknum]];
  } else { &errorproc ("Not valid diskname: $diskname\n");
   }
 }

}
}
}
}



#update values in RRD file
sub Update_Object {
 my $self = shift;

 &diskcollect; #collect disk data
 my $diskname = $self -> {'DESC'}{'DISK'};
 my $refdata = ['U','U','U','U','U'];
 if (defined ($disktable{$diskname})) {
  #found disk
  $refdata = $disktable{$diskname};
 }


my $data;

if ($self -> {'DESC'}{'TYPE'}) {
$data ="$diskcollectstart:$$refdata[2]:$$refdata[4]";
} else {
$data ="$diskcollectstart:$$refdata[1]:$$refdata[3]";
}

#finally update RRD file
 return ($data);
}


sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

 my  $typ= $self-> {'DESC'}{'TYPE'} ; #type of graph
 my $diskname=$self-> {'DESC'}{'DISK'} ; #low level od system load

 push (@$Refsource,"--vertical-label");

if ($typ) {
  push (@$Refsource,$dict{DISK_VLABEL_BLOCK});
 } else {
  push (@$Refsource,$dict{DISK_VLABEL_OPER});
 }

  push (@$Refsource,"DEF:read=$rrd:read:AVERAGE");
  push (@$Refsource,"DEF:write=$rrd:write:AVERAGE");
  push (@$Refsource,"AREA:read#0000FF:$dict{DISK_READ}");
  push (@$Refsource,"STACK:write#FF0000:$dict{DISK_WRITE}");

}


#edit additional primary fields
sub EditObjPrimary {
my $self = shift;
my $RefTags = shift;

#show additional template for this object
Misc::Gen ($RefTags, 'ediskpri.html',1);
}

#check if need recreate RRD file
sub CompareEditObj {
 my $self = shift;
 my $newobj = shift;
 my $Result = 0;
 $Result = 1 if ($self-> {'DESC'}{'TYPE'} ne $newobj-> {'DESC'}{'TYPE'});
 $Result = 1 if ($self-> {'DESC'}{'DISK'} ne $newobj-> {'DESC'}{'DISK'});
 return ($Result);
}


#---------End-TDISK-----------------------------------------

package TINTGrapher;
use vars qw ( @ISA );
use Carp;
use Misc;
use Misc qw ( show_command ConvB );
use Lstatobj;

my %collect; #table clolected data
my $lastrunme1=-10;


@ISA = qw ( TGrapher );
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','int');
 #setting default values
 $self -> name ( 'intXX');
 $self ->{'COLLECT'} = \%collect;
 $self -> {'TITLE_TAG'} = 'INT_DEFTITLE';
 $self -> {'DESC'}{'INTERFACE'} = shift;
 $self -> {'DESC'}{'LIMIT'} = 0;
 $self -> {'DESC'}{'SPEED'} = 1; #0 < 1Mbit/s , 1 - 10 , 2 -100, 3 - undef
 $self -> {'DESC'}{'TYPE'} = 0;     #0 bytes or 1 packets
 $self -> {'DESC'}{'BITS'} = 1;     #0 bytes/s or 1 bits/s
 $self->AddToRADIOBOX ('SPEED','TYPE','BITS'); #for editing as radio box
 $self -> {'HELP_FILE'} = 'int.html'; #set help file

 $self -> {'HAS_INFO'} = 1; #this object has additional info

# $self -> {'UPDATE_PERIOD'} = '5m';
 bless ($self, $class);
 return $self;
}

sub Info { #additional info
 my $self = shift;
 my $ifconfig = $self -> {'CONFIG'}{'IFCONFIG'};
 show_command ($ifconfig);
 }

sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 my $speed = $self -> {'DESC'}{'SPEED'};
 if ($speed == 3) { $speed='U'}
  else {$speed = int (1E5 * (10 ** $speed)) };
 if (($self -> {'DESC'}{'TYPE'}) && ($speed ne 'U') ) { $speed = $speed * 0.015 }

 push (@$Refsource,"DS:input:COUNTER:$rrdstep:0:$speed");
 push (@$Refsource,"DS:output:COUNTER:$rrdstep:0:$speed");
  return 1;

}


#collecting informations about interfaces
sub Get_Interface_Data {
 if ($lastrunme1 != $lastrun) {
 $collect{start} = time; #save time;
 #open file with data
 my $filename=$sysconfig {'PROC_INT_FILE'};
 open (FILE, "<$filename" ) || carp "Can't open file $filename: $! \n";
 while (<FILE>) {
  if (/:/) {
  my ($name, $data) = split (/:/,$_);
  $name =~ s/^\s+//g;
  $data =~ s/^\s+//g;
  my @data2 = split (/\s+/,$data);
  my @int_data = ();
  push (@int_data,$data2[0]); #bytes received
  push (@int_data,$data2[8]); #bytes sent
  push (@int_data,$data2[1]); #pakcket received
  push (@int_data,$data2[9]); #packet sent
  $collect{$name} = [@int_data]; #add to interface data;
  }
 }
 close FILE;
 $lastrunme1 = $lastrun;
 }
}


#update values in RRD file
sub Update_Object {
 my $self = shift;
 #collect data about interfaces
 Get_Interface_Data ();

 my  $typ = $self-> {'DESC'}{'TYPE'} ; #type of graph packets or bytes
 my  $interface = $self-> {'DESC'}{'INTERFACE'} ; #interface name
 my  $collect = $self-> {'COLLECT'} ; #reference to collected data
 my @daneint = ("U","U","U","U");
 my $refdane = \@daneint;
 if (defined $$collect{$interface}) {
  #interface found
  $refdane = $$collect{$interface};
 };

 my $data;

 if ($typ) {  #packets
  $data ="$$collect{start}:$$refdane[2]:$$refdane[3]";
} else {     #bytes
  $data = "$$collect{start}:$$refdane[0]:$$refdane[1]";
}

#finally update RRD file
 return ($data);
}


sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

 my  $typ = $self-> {'DESC'}{'TYPE'} ; #type of graph packets or bytes
 my  $limit = $self-> {'DESC'}{'LIMIT'} ; #limit of values
 my  $bits = $self-> {'DESC'}{'BITS'} ; #limit of values
 my $mult=8; #for multiple bytes

 push (@$Refsource,"--vertical-label");
 #eval some statistic
 my $refdata = $self->ExtraData ();


 if ($typ) {
  push (@$Refsource,$dict {INT_VLABEL_PAC});
 } else {
  if ($bits) {push (@$Refsource,$dict {INT_VLABEL_BIT})}
   else {push (@$Refsource,$dict{INT_VLABEL_BYTE}); $mult=1;}
 }

  push (@$Refsource,"DEF:input=$rrd:input:AVERAGE");
  push (@$Refsource,"DEF:output=$rrd:output:AVERAGE");
  push (@$Refsource,"CDEF:total=input,output,+");
if ($limit) {
if ($typ) {
push (@$Refsource,"CDEF:in=input,DUP,$limit,LT,EXC,$limit,IF");
push (@$Refsource,"CDEF:out=output,DUP,$limit,LT,EXC,$limit,IF");
push (@$Refsource,"CDEF:all=total,DUP,$limit,LT,EXC,$limit,IF");

} else {
push (@$Refsource,"CDEF:in=input,$mult,*,DUP,$limit,LT,EXC,$limit,IF");
push (@$Refsource,"CDEF:out=output,$mult,*,DUP,$limit,LT,EXC,$limit,IF");
push (@$Refsource,"CDEF:all=total,$mult,*,DUP,$limit,LT,EXC,$limit,IF");
}
}
 else {
#without limit
if ($typ){
push (@$Refsource,"CDEF:in=input");
push (@$Refsource,"CDEF:out=output");
push (@$Refsource,"CDEF:all=total");
} else {
push (@$Refsource,"CDEF:in=input,$mult,*");
push (@$Refsource,"CDEF:out=output,$mult,*");
push (@$Refsource,"CDEF:all=total,$mult,*");
}
}

  my $out_data = $refdata -> {'output'}; #stats for output
  my $in_data = $refdata -> {'input'}; #stats for output
  my @total_data;
  my $labelsize=8;
  #add input and output statistic
  for (my $i=0; $i<@$out_data;$i++) { push (@total_data, $in_data->[$i] + $out_data->[$i])}

  push (@$Refsource,"COMMENT:$dict{'INT_TABLE'}\\s");
  push (@$Refsource,"COMMENT:\\s");
if ($typ) {
  #packet
  push (@$Refsource,"COMMENT:                 [pkt]  [p/s]  [p/s]  [p/s]  [p/s]\\s");
} else
 { #bytes
   push (@$Refsource,"COMMENT:                  [B]  [B/s]  [B/s]  [B/s]  [B/s]\\s");
 }
  push (@$Refsource,"COMMENT:\\s");
  #correct for translations
  my $spacing = " " x ($labelsize -length ($dict{'INT_TOTAL'}));
  push (@$Refsource,"AREA:all#0000FF:$dict{INT_TOTAL}");
  push (@$Refsource,"COMMENT: $spacing");

  my $data = \@total_data;
  for (my $i=0; $i<@$data;$i++) { $data->[$i] = ConvB ($data->[$i])}

  push (@$Refsource,"COMMENT:$data->[0] $data->[1] $data->[2] $data->[3] $data->[4]");

  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");

 push (@$Refsource,"LINE2:out#00FF00:$dict{INT_OUTPUT}");
  $spacing = " " x ($labelsize -length ($dict{'INT_OUTPUT'}));
  push (@$Refsource,"COMMENT: $spacing");

  $data = $out_data; #stats for output
  #convert to value with prefix
  for (my $i=0; $i<@$data;$i++) { $data->[$i] = ConvB ($data->[$i])}

  push (@$Refsource,"COMMENT:$data->[0] $data->[1] $data->[2] $data->[3] $data->[4]");

  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");


push (@$Refsource,"LINE2:in#FF0000:$dict{INT_INPUT}");
  $spacing = " " x ($labelsize -length ($dict{'INT_INPUT'}));
  push (@$Refsource,"COMMENT: $spacing");
  $data = $in_data; #stats for input
  #convert to value with prefix
  for (my $i=0; $i<@$data;$i++) { $data->[$i] = ConvB ($data->[$i])}

  push (@$Refsource,"COMMENT:$data->[0] $data->[1] $data->[2] $data->[3] $data->[4]");

}



#edit additional primary fields
sub EditObjPrimary {
my $self = shift;
my $RefTags = shift;

#show additional template for this object
Misc::Gen ($RefTags, 'eintpri.html',1);
}

#check if need recreate RRD file
sub CompareEditObj {
 my $self = shift;
 my $newobj = shift;
 my $Result = 0;
 $Result = 1 if ($self-> {'DESC'}{'TYPE'} ne $newobj-> {'DESC'}{'TYPE'});
 $Result = 1 if ($self-> {'DESC'}{'SPEED'} ne $newobj-> {'DESC'}{'SPEED'});
 return ($Result);
}



#---------END TINTGRAPHER-----------------------------------
package TPARTGrapher;
use vars qw ( @ISA );
use Misc;
use Lstatobj;

@ISA = qw ( TADVGrapher );
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','part');
 #setting default values
 $self -> name ( 'partXX');
 $self -> {'TITLE_TAG'} = 'PART_DEFTITLE';
 my @PART;
 $self -> {'DESC'}{'ADV'} = [ @PART ]; #reference to partition info
 $self -> {'HAS_INFO'} = 1; #this object has additional info
 $self -> {'HELP_FILE'} = 'part.html'; #set help file

 $self -> {'ADV_DESC'} = {name => 'MOUNT', desc => 'PART_EDIT_MOUNT', size => 20, maxlength => 40};

 bless ($self, $class);
 return $self;
}

sub Info { #additional info
 my $self = shift;
 my $partfile = $self -> {'CONFIG'}{'PROC_PART_FILE'};
 if (open (FILE, "<$partfile") && (my @content2=<FILE>) && (close FILE) ) {
  print "<TABLE BORDER=1 BORDERCOLOR=#000000 CELLSPACING=0>\n";
  my $first=1;
  foreach my $line (@content2) {
   chomp ($line);
   $line =~ s/^\s+//g;
   if ($line) {
    if ($first) {
    print "<TR BGCOLOR=#A0A0FF ALIGN=RIGHT>\n";
    $first = 0;
    } else
     {print "<TR ALIGN=RIGHT>\n";}
    my @cont = split (/\s+/,$line);
    foreach my $value (@cont) {
     print "<TD>$value</TD>";
    }
    print "</TR>\n";
   }
  }
   print "</TABLE>\n";
 }
 }


sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 my $PartRef =  $self -> {'DESC'}{'ADV'}; #reference to array of partitions
 if (@$PartRef) { #has any elements
 for (my $i=0; $i < @$PartRef; $i++) {
  push (@$Refsource,"DS:total$i:GAUGE:$rrdstep:0:U"); #for each mount point
  push (@$Refsource,"DS:usage$i:GAUGE:$rrdstep:0:U");
  push (@$Refsource,"DS:free$i:GAUGE:$rrdstep:0:U");
  }
 return 1;
 } else {return 0}

}


#check if need recreate RRD file
sub CompareEditObj {
 my $self = shift;
 my $newobj = shift;
 my $Result = 0;
 my $newobjpart = $newobj-> {'DESC'}{'ADV'};
 my $objpart = $self-> {'DESC'}{'ADV'};
 if ($#$newobjpart != $#$objpart ) {
  $Result=1; #difference in elements count
   }
 return ($Result);
}


#update values in RRD file
sub Update_Object {
 my $self = shift;
 my $data = "";
 my  %Info;  #array to collect info

my $df = $self -> {'CONFIG'}{'DF'}; #path to df command
if (-x $df ) {
#start collect info about mounted partitions
my $start = time;
my @mounted =`$df -P`;
#"pozbycie sie pierwszej linijki opisu
shift @mounted; #without first line
foreach (@mounted) {
 my @point = split;
 my %newpoint;
 my $pointname = $point [5];
 $newpoint {'total'}= $point [1];
 $newpoint{'used'} = $point [2];
 $newpoint{'free'} = $point [3];
 $Info {$pointname} = {%newpoint};
 }

$data= $start;
my $refPart = $self->{'DESC'}{'ADV'}; #reference to data for collect

foreach my $row (@$refPart ){
  #default values
  my ($tot,$usa,$fre)=(0,0,0);
  if (defined ($Info {$row->{'MOUNT'}})) {
  #found in collected data
   my $ref = $Info {$row->{'MOUNT'}};
   $tot=$ref ->{'total'};
   $usa=$ref ->{'used'};
   $fre=$ref ->{'free'};
   }
   $data .=":$tot:$usa:$fre";
  }
#finally update RRD file
}
 return ($data);
}


sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

 ResetPalette (); #reset default color 

  push (@$Refsource,"--upper");
  push (@$Refsource,"100");
  push (@$Refsource,"--vertical-label");
  push (@$Refsource,$dict{PART_VLABEL});
  push (@$Refsource,"COMMENT:$dict{PART_TABLE_CAPTION}");

  my $RefPart=$self->{'DESC'}{'ADV'};
  if (@$RefPart) {
  #foreach mount point
  for (my $i=0; $i<@$RefPart; $i++) {

  my $row = $$RefPart[$i];
  my $hide = $row->{'HIDE'} if (defined ($row->{'HIDE'}));
  next if ($hide);

  push (@$Refsource,"DEF:total$i=$rrd:total$i:AVERAGE");
  push (@$Refsource,"DEF:usage$i=$rrd:usage$i:AVERAGE");
  push (@$Refsource,"DEF:free$i=$rrd:free$i:AVERAGE");
  push (@$Refsource,"CDEF:part$i=usage$i,100,*,total$i,/");
 # my $kas=/"/";
  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");

  #select colour
  my $colour;
  if ($row->{'COLOR'}) {
  $colour = $row->{'COLOR'};
 } else {
  $colour = GetColor ();
  }

  my $mountpoint = $row->{'MOUNT'};
  push (@$Refsource,"LINE2:part$i\#$colour:$mountpoint");
  my $mountdesc = $row->{'DESC'};
  $mountdesc='' if (! defined ($mountdesc));

  my $mountdesc1 = " " x (22 -length ($mountpoint)).$mountdesc;
  $mountdesc1 .= " " x (22 -length ($mountdesc));

  push (@$Refsource,"COMMENT:$mountdesc1");
  push (@$Refsource,"GPRINT:total$i:LAST:\%10.lf");
  push (@$Refsource,"GPRINT:usage$i:LAST:\%10.lf");
  push (@$Refsource,"GPRINT:free$i:LAST:\%10.lf");
  } #end for
 }
}
#---------END TPARTGRAPHER-----------------------------------
package TIPGrapher;
use vars qw ( @ISA );
use Misc;
use Misc qw ( ConvB );
use Lstatobj;

@ISA = qw ( TADVGrapher );
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','ip');
 #setting default values
 $self -> name ( 'ipXX');
 $self -> {'TITLE_TAG'} = 'IP_DEFTITLE';
 my @IP;
 $self -> {'DESC'}{'ADV'} = [ @IP ]; #reference to statistic info
 $self -> {'DESC'}{'SPEED'} = 1; #max speed see TINTGraph
 $self -> {'DESC'}{'TYPE'} = 0;     #0 bytes or 1 packets
 $self -> {'DESC'}{'BITS'} = 1;     #0 bytes pers or 1 bits pers
 $self -> {'DESC'}{'BAR'} = 1;     #0 line or 1 bar
 $self -> {'DESC'}{'EXTRA_INFO'} = 1;     # 1 for extra info
 $self->AddToRADIOBOX ('SPEED','TYPE','BITS','BAR'); #for editing as radio box
 $self->AddToCHKBOX ('EXTRA_INFO'); #for editing as check box
 $self -> {'HELP_FILE'} = 'ip.html'; #set help file

 $self -> {'ADV_DESC'} = {name => 'MARK', desc => 'IP_EDIT_FILTR', size => 20, maxlength => 40};

 bless ($self, $class);
 return $self;
}

sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 my $PartRef =  $self -> {'DESC'}{'ADV'}; #reference to array of rules

 my $speed = $self -> {'DESC'}{'SPEED'};
 if ($speed == 3) { $speed='U'}
  else {$speed = int (1E5 * (10 ** $speed)) };
 if (($self -> {'DESC'}{'TYPE'}) && ($speed ne 'U') ) { $speed = $speed * 0.015 }

if (@$PartRef) { #has any elements
 for (my $i=0; $i < @$PartRef; $i++) {
   push (@$Refsource,"DS:m$i:COUNTER:$rrdstep:0:$speed");
 }
 return 1;
 } else {return 0}

}

#edit additional primary fields
sub EditObjPrimary {
my $self = shift;
my $RefTags = shift;

#show additional template for this object
Misc::Gen ($RefTags, 'eippri.html',1);
}


#check if need recreate RRD file
sub CompareEditObj {
 my $self = shift;
 my $newobj = shift;
 my $Result = 0;
 my $newobjpart = $newobj-> {'DESC'}{'ADV'};
 my $objpart = $self-> {'DESC'}{'ADV'};
 if ($self->{'DESC'}{'SPEED'} != $newobj->{'DESC'}{'SPEED'} ) {$Result=1}
 elsif ($self->{'DESC'}{'TYPE'} != $newobj->{'DESC'}{'TYPE'} ) {$Result=1}
 elsif ($#$newobjpart != $#$objpart ) {
  $Result=1; #difference in elements count
   }
 return ($Result);
}

my $lastrunme2=-2;
my %collect_mark =(); #table of collected marks
my $ipchains ="";
my $iptables="";
$ipchains = $sysconfig{'IPCHAINS'} if (defined ($sysconfig{'IPCHAINS'})); #path to ipchains command
$iptables = $sysconfig{'IPTABLES'} if (defined ($sysconfig{'IPTABLES'}));; #path to iptables command


#parse RefInfo and extract filters to RefData
#mangle for iptables
sub collect_data {
my $RefData = shift;
my $RefInfo = shift;
my $mangle = shift;

$mangle = 0 if (! defined ($mangle));

  my ($mark, $bytes, $pkts, $markpos, $bytespos, $pktspos, $curchain,$curline);
  foreach my $line ( @$RefInfo) {
  next if ($line =~ /^\s*$/);
#  print "$line\n";
 if ($line =~ /^Chain\s+(\S+)/) { #extrct new chain
  $curchain = $1;
  $curchain .= '_M' if ($mangle == 1); #for iptables and mangle
  $curchain .= '_N' if ($mangle == 2); #for iptables and nat

  if ($line =~ /\(policy\s+\w+\:?\s*(\d+)\s+\w+\,\s*(\d+)/) {   #main chain, test it
#   print ("$curchain",$curline,"   ", $line);
   $curline=0;
   $RefData ->{$curchain.$curline} = [$1, $2]; #save pkts, $bytes
  }
   $curline=1;
 }elsif ($line =~ /^\s*pkts/) {  #line with description
  $markpos = index ($line, 'mark');
  $bytespos = index ($line, 'bytes');
  $pktspos = index ($line, 'pkts');
}  elsif  ($line =~ /^\s*\d+/) {
 #line contains valid data
  if ( $line =~ /^\s*(\d+)\s+(\d+)/) {;
    $pkts = $1;
    $bytes = $2;
 } else { #for high value ipchans counter
  $pkts = substr ($line,0, $pktspos +4);
  $pkts =~ s/\s+//g;
  $bytes = substr ($line, $pktspos +4, $bytespos-$pktspos+1);
  $bytes =~ s/\s+//g;
  }
  if ($line =~ /MARK set (0x\w+)/) { #iptables version
   $mark = $1;
  } else {
   $mark = substr ($line, $markpos, 10); #for ipchains test if mark exists
  }
  if  ($mark =~/^0x/) {
  #has mark
  $mark =~ s/\s+//g;
  $mark = 'm'.hex ($mark);
  if (defined ($RefData ->{$mark})) {
  #add to exists
  my $ref = $RefData ->{$mark};
  $ref->[0] += $pkts;
  $ref->[1] += $bytes;
  } else {
    $RefData ->{$mark} = [$pkts, $bytes];
     }
  } #end mark ok
 $RefData ->{$curchain.$curline++} = [$pkts, $bytes]; #save pkts, $bytes
 } #valid data
 } #end for
} #end sub


#collect data about marked ip chain
sub collectmarks {

 if ($lastrunme2 != $lastrun) {
 my $forceIPCHAINS= $userconfig {'FORCE_IPCHAINS'}; #if force IPCHAINS using
 $forceIPCHAINS=0 if (! defined ($forceIPCHAINS));
 my ($markpos, $bytespos, $pktspos);
 $lastrunme2 = $lastrun;
 %collect_mark = (); #forget all elements
  #store collect time
 $collect_mark{'mstart'} = time;
 my @info;

  #test if use iptable
  if ( ( ! $forceIPCHAINS) && (-x $iptables) ) {
  #iptables version
 @info = `$iptables -L -n -v -x`;
 # my $kas=/"`"
  if ($? > 0) {
   print "Problem with iptables ($iptables): $! \n";
   return;
  }
 collect_data (\%collect_mark, \@info);
 @info = `$iptables -L -n -v -t mangle -x`;
 # my $kas=/"`"
 collect_data (\%collect_mark, \@info,1); #for mangle and MARKs


 } #end iptables
  else
  {
   if ( -x $ipchains ) {
  #ipchains version
 @info = `$ipchains -L -n -v -x`;
 # my $kas=/"`"
  if ($? > 0) {
   print "Problem with ipchains ($ipchains): $! \n";
   return;
  }
 collect_data (\%collect_mark, \@info);
  } #end ipchains
 } #end else
}#lastrunme
}#collectmarks



#update values in RRD file
sub Update_Object {
 my $self = shift;
 my  %Info;  #array to collect info
 collectmarks () ; #run procedure to collect marks
 my $data="";
 my $IPRef = $self -> {'DESC'}{'ADV'};
 if (@$IPRef) {
 my $collect = \%collect_mark;
 $data= $collect->{'mstart'} ;
 my $packet = $self -> {'DESC'}{'TYPE'} ;     #0 bytes or 1 packets
 my @temptab= (0,0); #tempolary variable
 for (my $i=0; $i<@$IPRef; $i++ ) {
#  print $marked[1],"\n";
  my ($bytes, $pkts, $ref);
  $bytes =0;
  $pkts =0;
  my $MarkExp = $$IPRef[$i]->{'MARK'};
  while ($MarkExp =~ /([\+\-]?\w+)/g) {
  my $mark = $1;
  my $markname = $1;
  $markname =~ s/[\+\-]//g;
  if (defined ($collect-> {$markname})) {
   $ref =$collect-> {$markname};
  }  else {
#    &errorproc ("Brak zaznaczenia ip: $mark w $marked[3]\n");
   $ref = \@temptab;
  }
  if ($mark=~/^\-/) {
  #substarction
  $bytes -= $$ref[1];
  $pkts -= $$ref[0];
  } else {
  $bytes += $$ref[1];
  $pkts += $$ref[0];
  }
 } #end while


if ($packet) {
  $data  .= ":".$pkts;
 } else {
  $data  .= ":".$bytes;
 }

  } #ernd for
} #end if
 return ($data);
}


sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

 ResetPalette (); #reset default color palette

 my $RefIP  = $self -> {'DESC'}{'ADV'}; #reference to statistic info
 my $Type = $self -> {'DESC'}{'TYPE'};     #0 bytes or 1 packets
 my $Bits = $self -> {'DESC'}{'BITS'};     #0 bytes/s or 1 bits per s
 my $Bar = $self -> {'DESC'}{'BAR'};     #0 line or 1 bar



  push (@$Refsource,"--vertical-label");
if ($Type) {
  push (@$Refsource,$dict{IP_VLABEL_PAC});
 } else {
 if ($Bits) {  push (@$Refsource,$dict{IP_VLABEL_BIT}) }
  else {
   push (@$Refsource,$dict{IP_VLABEL_BYTE});
  }
 }

#tempolary
my $longinfo=$self -> {'DESC'}{'EXTRA_INFO'};
my $refdata;

if (@$RefIP) {
 if ($longinfo) {
  #additonal info
   #eval some statistic
  $refdata = $self->ExtraData ();
  push (@$Refsource,"COMMENT:$dict{'IP_TABLE'}\\s");
  push (@$Refsource,"COMMENT:\\s");
if ($Type) {
  #packet
  push (@$Refsource,"COMMENT:                 [pkt]  [p/s]  [p/s]  [p/s]  [p/s]\\s");
} else
 { #bytes
   push (@$Refsource,"COMMENT:                  [B]  [B/s]  [B/s]  [B/s]  [B/s]\\s");
 }
  push (@$Refsource,"COMMENT:\\s");

 }
 my $spacing;
 my $labelsize=8;
 for (my $i=0; $i < @$RefIP; $i++) {
   my $Row = $$RefIP[$i]; #reference to hash
   my $hide = $Row->{'HIDE'} if (defined ($Row->{'HIDE'}));
   next if ($hide);

  push (@$Refsource,"DEF:m$i=$rrd:m$i:AVERAGE");
  if (!$Type && $Bits ) {
   push (@$Refsource,"CDEF:sm$i=m$i,8,*"); #for bits/s
   } else { push (@$Refsource,"CDEF:sm$i=m$i") }; #for bytes per s and packets
   my $colour = $Row->{'COLOR'};
   $colour = GetColor () if (! $colour); #automatic
   my $desc = $Row->{'DESC'};
   $desc =$Row->{'MARK'} if (! $desc);
  if (!$Bar) {
   #as linie
   push (@$Refsource,"LINE2:sm$i\#$colour:$desc");
  }  else {
   if ($i) {
    #not first bar
     push (@$Refsource,"STACK:sm$i\#$colour:$desc");
   } else {
   #first
    push (@$Refsource,"AREA:sm$i\#$colour:$desc");
   }
   }
 if ($longinfo) {
  #additonal info
  my $data = $refdata -> {"m$i"}; #stats for output
  $spacing = " " x ($labelsize -length ($desc));
  push (@$Refsource,"COMMENT: $spacing");
  #convert to Kilo Mega or Giga
  for (my $i=0; $i<@$data;$i++) { $data->[$i] = ConvB ($data->[$i])}

  push (@$Refsource,"COMMENT:$data->[0] $data->[1] $data->[2] $data->[3] $data->[4]");

  push (@$Refsource,"COMMENT:\\s");
  push (@$Refsource,"COMMENT:\\s");

 } #end add info
 } #end for
 }
}

 

#---------END TIPGRAPHER-----------------------------------

package TPINGGrapher;

use IPC::Open3;
use vars qw ( @ISA );
use Misc;
use Lstatobj;

@ISA = qw ( TADVGrapher );

sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new ();
 LoadLangData ('','ping');
 #setting default values
 $self -> name ( 'pingXX');
 $self -> {'TITLE_TAG'} = 'PING_DEFTITLE';
 my @IP;
 $self -> {'DESC'}{'ADV'} = [ @IP ]; #reference to statistic info
 $self -> {'DESC'}{'BAR'} = 1;     #0 line or 1 bar
 $self -> {'DESC'}{'COUNT'} = 3;     #count ping packet
 $self -> {'DESC'}{'DELAY'} = 1000;  #delay beetwen packet
 $self -> {'DESC'}{'LOST'} = 0;  #display delay or lost packets
 $self->AddToRADIOBOX ('BAR','LOST'); #for editing as radio box
 $self -> {'HELP_FILE'} = 'ping.html'; #set help file

 $self -> {'ADV_DESC'} = {name => 'ADDR', desc => 'PING_EDIT_ADDR', size => 20, maxsize => 40};

 bless ($self, $class);
 return $self;
}

sub Create_Object {
 my $self = shift;
 my $rrdstep = shift;
 my $Refsource = shift;

 my $PartRef =  $self -> {'DESC'}{'ADV'}; #reference to array of IPdata

if (@$PartRef) { #has any elements

 for (my $i=0; $i < @$PartRef; $i++) {
   push (@$Refsource,"DS:avg$i:GAUGE:$rrdstep:0:U");
#   push (@$Refsource,"DS:lost$i:ABSOLUTE:$rrdstep:0:U");
   push (@$Refsource,"DS:lost$i:GAUGE:$rrdstep:0:U");

 }
 return 1;
 } else {return 0}

}

#edit additional primary fields
sub EditObjPrimary {
my $self = shift;
my $RefTags = shift;

#show additional template for this object
Misc::Gen ($RefTags, 'epingpri.html',1);
}


#check security
sub Check_Security {
 my $self = shift;
 my $ok="Fields Count or Delay couldnt be empty";
 my $count = $self -> {'DESC'}{'COUNT'} ;     #count ping packet
 my $delay = $self -> {'DESC'}{'DELAY'};  #max delay beetwen packet
 if ( $count and $delay) {
 if ((length ($count) < 3) and (length ($delay) < 6)) {
 if (($count =~ /\D/) or ($delay =~ /\D/)) {
  return ("Fields Count and Delay have to be number"); #insecure
 }
 else {
  $ok = $self -> SUPER::Check_Security ();

 }
 }
 }
# my $RefIP = $self -> {'DESC'}{'ADV'};
#if (@$RefIP) {
# for (my $i=0; $i < @$RefIP; $i++) {
#   my $Row = $RefIP->[$i]; #reference to hash
#   my $addr =$Row->{'ADDR'};
#   if ($addr) {
#    return ( '<B>Addres IP</B> have to be in numeric format eg. 127.0.0.1')  if (!  ($addr =~ /^\d+\.\d+\.\d+\.\d+$/));
#   }
#}
#}


 return ($ok);
}

#update values in RRD file
sub Update_Object {
 my $self = shift;
 my $data=0;
 my $IPRef = $self -> {'DESC'}{'ADV'};
 my $count = $self -> {'DESC'}{'COUNT'} ;     #count ping packet
 my $delay = $self -> {'DESC'}{'DELAY'} ;  #max delay beetwen packet

 if (@$IPRef) {
 my $fping = $self -> {'CONFIG'}{'FPING'};
 if (defined ($fping)) {
 if ($fping) {
 my %OutArray;

 my $fpingargs = "-C $count -p $delay -A -q -u";
 my @output;
 my @erroutput;
 
 #safe run this command
 $SIG{'CLD'} = "IGNORE"; #prevent zombies
 eval {
 $fpingpid = open3(\*INPUT, \*OUTPUT, \*ERROR, $fping, $fpingargs);

 foreach my $RefHash (@$IPRef) {
  print INPUT "$$RefHash{'ADDR'}\n";
  }
 close(INPUT);
 @output=<OUTPUT>;
 @erroutput=<ERROR>;
 close (OUTPUT);
 close (ERROR);
 waitpid ($fpingpid, 0);
}; #end eval
 $SIG{'CLD'} = "DEFAULT";         #restore default handler
 
 if (! ($@)) {
 foreach my $line (@erroutput) {
  if ($line =~ /:/) {
   chomp ($line);
   my ($comp, $data) = split (/:/,$line,2);
   $comp =~ s/\s+//g;
   $data =~ s/^\s+//g;
   $data =~ s/\s+$//g;
   my @results = split (/\s+/,$data);

   my $sum=0;
   my $lost=0;
   my $okpacket=0;
   foreach my $res (@results) {
    if (! ($res =~ /-/)) {
     $sum += $res;
     $okpacket++;
    } else { $lost++;}

   }
   my $avg=0;
   $avg=$sum/$okpacket    if ($okpacket);
   # my $kas=/"/";
   my %ThisResult;
   $ThisResult {'AVG'} = $avg;
   $ThisResult {'LOST'} = $lost;
   #add to outarray
   $OutArray {$comp} = { %ThisResult };
  }
 }
} else { print "Error running fping"}

 #store time
 $data=time;

 #find results
 foreach my $RefHash (@$IPRef) {
  my $addr = $$RefHash{'ADDR'};
  my $avg='U';
  my $lost='U';
  if (defined ($OutArray {$addr})) {
   my $ref = $OutArray {$addr};
   $avg = $$ref {'AVG'};
   $lost = $$ref {'LOST'};
  }
  $data .="\:$avg\:$lost";
  }
}}
} #end if
 return ($data);
}


sub Draw_Object {
 my $self = shift;
 my $rrd =shift;
 my $Refsource =shift;

 ResetPalette (); #reset default color palette

 my $RefIP  = $self -> {'DESC'}{'ADV'}; #reference to statistic info
 my $Bar = $self -> {'DESC'}{'BAR'};     #0 line or 1 bar
 my $lost = $self -> {'DESC'}{'LOST'};   #dispaly lost packets


 push (@$Refsource,"--vertical-label");
 if ($lost) {
  push (@$Refsource,$dict{IP_VLABEL_LOST});
 } else
 {
  push (@$Refsource,$dict{IP_VLABEL_RESPONSE});
 }

if (@$RefIP) {
 for (my $i=0; $i < @$RefIP; $i++) {
   my $Row = $$RefIP[$i]; #reference to hash
   my $hide = $Row->{'HIDE'} if (defined ($Row->{'HIDE'}));
   next if ($hide);

  if ($lost) {
  push (@$Refsource,"DEF:avg$i=$rrd:lost$i:AVERAGE");
  } else
  {
  push (@$Refsource,"DEF:avg$i=$rrd:avg$i:AVERAGE");
  }

   my $colour = $Row->{'COLOR'};
   $colour = GetColor () if (! $colour); #automatic
   my $desc = $Row->{'DESC'};
   $desc =$Row->{'ADDR'} if (! $desc);
  if (!$Bar) {
   #as linie
   push (@$Refsource,"LINE2:avg$i\#$colour:$desc");
  }  else {
   if ($i) {
    #not first bar
     push (@$Refsource,"STACK:avg$i\#$colour:$desc");
   } else {
   #first
    push (@$Refsource,"AREA:avg$i\#$colour:$desc");
   }
   }

 } #end for
 } #end if
}

#-------end TPINGGrapher
