package Users;

#begin graph definiction
package TCount_UserGrapher;
use strict;
use Carp;	#for errors displaying
use Misc;	#misc linuxstat procedures
use Lstatobj; #primary object definiction

use vars qw ( @ISA );
@ISA = qw ( TADVGrapher ); #inherited form TADVGrapher

##### constructor ##################
sub new {
 my $proto = shift;
 my $class = ref ($proto) || $proto;
 my $self = $class -> SUPER::new (); #run inherited constructor
 LoadLangData ('','count_users'); #load dictionary values

 #setting default values
 $self -> {'TITLE_TAG'} = 'COUNTUSERS_DEFTITLE'; #default title
 $self -> {'BAR'} = 1; # 1 for user bar select
 $self -> {'VERTICAL_LABEL'} =$dict {'USERS_VLABEL'}; #vertical label
 $self -> {'DS_TYPE'} = 'GAUGE'; #data source type
 $self->{'NO_INSERT'} = 1; #this graph can not  delete and insert new adv properties
 $self -> {'ADV_DESC'} = {name => '', desc => '', size => 0, maxsize => 0};#setting for edit
 $self->{'SHOW_TABLE_DATA'} = [(0,1,1,1,1)]; #define whitch columns can display
 $self -> {'HAS_INFO'} = 1; #this object has additional info
 $self -> {'HELP_FILE'} = 'users.html'; #set help file

 $dict {'TABLE_DESC'} = $dict {'USERS_TABLE'}; #table description

 bless ($self, $class);
 return $self;
}

#fill data on new objects
sub OnNew {
 my $self = shift;
 my @ADV_DATA;
 my %row;
 #first field
 $row {'COLOR'} = ''; #add color field
 $row {'DESC'} = $dict {'LOGGED'}; #add graph label form dictionary
 $row {'BAR'} = 1; #draw as bar
 push (@ADV_DATA, { %row } ); #store
 $row {'COLOR'} = ''; #add color field
 $row {'DESC'} = $dict {'UNIQUE_LOGGED'}; #add graph label
 $row {'BAR'} = 0; #draw as line
 push (@ADV_DATA, { %row } ); #store
 $self -> {'DESC'}{'ADV'} = [ @ADV_DATA ] ; #reference to object info
}

#update values in RRD file
sub Update_Object {
 my $self = shift;
 my $start=time;

 #grab users command output
 my $users_com = $sysconfig{'USERS'}; #patch to users command
 if ( -x $users_com ) {
 my $users = `$users_com 2>&1`;

 #move user name to array
 chomp ($users);
 my @u_array = split (/\s/, $users);
 my $total=@u_array;

 #find unique
 my %uniq;
 foreach my $u (@u_array) {
 $uniq {$u} = 1 if (! exists ($uniq {$u}));
  }
 my $unique_users = keys %uniq;


 $start .=":$total:$unique_users"; #add to timestamp
 }
 return ($start);
}

sub Info { #additional info
 my $self = shift;
 my $to_run = $sysconfig {'W'}; #get w command
 if ( -x $to_run) {
 my @content;
 eval {
 $to_run .=' -h'; #additional switches
 open (FILE,"$to_run 2>&1 |") && (@content=<FILE>) && (close FILE);
 }; #end eval
 if (!$@){
  print "<TABLE BORDER=1 BORDERCOLOR=black CELLSPACING=0 CELLPADDING=5>\n";
  unshift (@content, ' USER TTY FROM LOGIN@ IDLE JCPU PCPU WHAT');
  my $color='yellow';
  foreach my $line (@content) {
   chomp ($line);
   $line =~ s/^\s+//;
   my @data = split (/\s+/, $line,8);
   print "<TR BGCOLOR=$color>";
   foreach my $d (@data) {
    print "<TD>$d</TD>\n";
   }
   print "</TR>";
   $color='white';
  }
  print "</TABLE>\n";
 }
}
}
## END class definition ###

use Misc;

BEGIN {
 #register all graphs from this package

 RegisterClass ('TCount_UserGrapher', '','count_users','COUNTUSERS_DESC',
 sub  { my $obj;  $obj = TCount_UserGrapher -> new ();  return ($obj); } );
}
